#!/bin/bash
#------------------------------------------------------------------------------
# Copyright (c) 2005-2023 Olaf Jaehrling <eisfair(at)ojaehrling.(dot)de>
#
# Creation: 13.02.2005 by Olaf Jaehrling
# Last Update: 15.04.2023 by Olaf Jaehrling
#
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License
#------------------------------------------------------------------------------
#
#exec 2>/tmp/B_F_b_install_trace.log
#set -x
package='brute_force_blocking'
export PATH="/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/sbin:/bin:/sbin"
if [ -f /etc/eisfair-system ]
then
    . /var/install/include/eislib
    . /var/install/include/check-eisfair-version
    mecho --info "installing brute_force_blocking ..."
fi
UPDATE=0

# aus Version 0.8.1 generiertes Log wieder entfernen
if [ -f /var/log/brute_force_blocking/ausgabelog.log ]
then
    rm /var/log/brute_force_blocking/ausgabelog.log
fi

if [ -f /tmp/brute_force_blocking_oldstat ]
then
    cp /tmp/brute_force_blocking_oldstat /usr/local/brute_force_blocking/brute_force_blocking_oldstat
fi

if [ -f /tmp/brute_force_blocking_freeoldstat ]
then
    cp /tmp/brute_force_blocking_freeoldstat /usr/local/brute_force_blocking/freeoldstat
fi

if [ -f /tmp/bfbconfig ]
then
    if [ -f /etc/eisfair-system ]
    then
        mv /tmp/bfbconfig /etc/config.d/brute_force_blocking
    else
        mv /tmp/bfbconfig /etc/default/brute_force_blocking
    fi
fi

if [ -f /etc/config.d/brute_force_blocking -o -f /etc/default/brute_force_blocking ]
then
    UPDATE=1
fi


mkdir -p /var/log/brute_force_blocking
mkdir -p /usr/local/brute_force_blocking/leer

### update configuration
if [ -f /usr/local/brute_force_blocking/$package-update.sh ]
then
    echo "loading previous configuration file ..."
    /usr/local/brute_force_blocking/$package-update.sh
fi
if [ -f /etc/eisfair-system ]
then
    if ! grep -wq setup.services.brute_force_blocking.menu /var/install/menu/setup.services.menu 
    then
        mecho --info "insert brute_force_blocking service menu ..."
        ### add menu
        /var/install/bin/add-menu              \
         setup.services.menu                \
         setup.services.$package.menu       \
         $package
    fi
fi

if [ -f /usr/local/brute_force_blocking_oldstat ]
then
    mv /usr/local/brute_force_blocking_oldstat /usr/local/brute_force_blocking/brute_force_blocking_oldstat
fi

if [ -f /etc/rc2.d/S99brute_force_blocking ]
then
    rm -f /etc/rc2.d/S99brute_force_blocking
    rm -f /etc/rc2.d/K01brute_force_blocking
fi
if [ -f /etc/rc2.d/K44brute_force_blocking ]
then
    rm -f /etc/rc2.d/K44brute_force_blocking /etc/rc2.d/S56brute_force_blocking
fi

### Leiche von Version 0.6.3 entfernen
if [ -f /var/log/PARTSIZE ]
then
    rm -f /var/log/PARTSIZE
fi

### leere Statusdateien erstellen
touch /usr/local/brute_force_blocking/brute_force_blocking_oldstat
touch /usr/local/brute_force_blocking/freeoldstat

## Neuinstallation oder update auf 1.0.25
#if [ -f /tmp/BFB_RFD-db ]
#then
#    cp /tmp/BFB_RFD-db /usr/local/brute_force_blocking/bfb.db
#fi
if [ ! -f /usr/local/brute_force_blocking/bfb.db ]
then
    echo "generate empty database"
    /usr/local/brute_force_blocking/bfb-db.sh init
fi
#echo "please run setup to configure and activate brute_force_blocking"
#sleep 5
if [ -f /etc/eisfair-system ]
then
    installed_version=`/var/install/bin/check-version $package 1.0.3`
    if [ "$installed_version" = "new" ]
    then
        echo "please run setup to configure and activating brute_force_blocking"
        sleep 5
    fi 
fi
rm -f /usr/local/brute_force_blocking/routefordelete

if [ -f /var/install/config.d/$package.sh ]
then
    /var/install/config.d/$package.sh > /dev/null
fi
if [ -f /routefordelete ]
then
    rm -f /routefordelete
fi

rm -f /tmp/brute_force_blocking_freeoldstat
rm -f /tmp/brute_force_blocking_oldstat

if [ -x /bin/systemctl ]
then
    systemctl daemon-reload
fi
if [ ! -f /usr/local/brute_force_blocking/excludelist-cust.list ]
then
    touch /usr/local/brute_force_blocking/excludelist-cust.list
fi
if [ -f /tmp/excludelist-cust.list ]
then
    mv /tmp/excludelist-cust.list /usr/local/brute_force_blocking/excludelist-cust.list
fi

rm -f /tmp/bfbwasrunning
if [ -f /etc/eisfair-system ]
then
    service disable brute_force_blocking
    service restart brute_force_blocking 
    systemctl enable brute_force_blocking.timer >/dev/null
else
    systemctl disable brute_force_blocking.service
    service brute_force_blocking restart
    systemctl enable brute_force_blocking.timer >/dev/null
fi

exit 0
