#!/bin/bash
#--------------------------------------------------------------------------
# /var/install/config.d/brute_force_blocking-update.sh - parameter update script
#
# Creation: 14.03.2011 OJae
# Last Update: 09.05.2023 OJae
#
# Copyright (c) 2005-2023 Olaf Jaehrling eisfair(at)ojaehrling(dot)de
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License
#--------------------------------------------------------------------------
#exec 2>/tmp/B_F_b_up-trace.log
#set -x

package='brute_force_blocking'
package_name='brute_force_blocking'
DATUM=`/bin/date +%Y"-"%m"-"%d`
FIRST=`echo $(($RANDOM % 60))" "$(($RANDOM % 24))`
FIRST2=`echo $(($RANDOM % 60))" "$(($RANDOM % 24))`

#echo "running $package-update.sh"

# include eislib
if [ -f /var/install/include/check-eisfair-version ]
then
    . /var/install/include/check-eisfair-version
fi

if [ -f /var/install/include/eislib ]
then
    . /var/install/include/eislib
fi
if [ -f /var/install/include/configlib ]
then
    . /var/install/include/configlib
fi
### ---------------------------------------------------------------------------
### cronerzeugung
### ---------------------------------------------------------------------------
    ### DOM=DayOfMonth
    mkdir -p /tmp/BFB_LEER
    cd /tmp/BFB_LEER
    FIRST=`echo $(($RANDOM % 60))" "$(($RANDOM % 24))`
    BFB_CLEAN_DATABASE="$FIRST * * *"
    cd - >/dev/null
    rm -fr /tmp/BFB_LEER

### ---------------------------------------------------------------------------
### Set the default values for configuration
### ---------------------------------------------------------------------------

START_BRUTE_FORCE_BLOCKING='no' # start brute_force_blocking yes/no
BFB_USE_RAMDISK='yes' # use RAMdisk for BFB yes/no
BFB_RUN_IN_DEBUG_MODE='no'   # run BFB in debug mode
BFB_DEBUGLOG_CRON_LOGROTATE='daily' #rotate debug_logfile
BFB_LOGLEVEL='debug' # loglevel for kernel messages
BFB_USE_IPTABLES_NFTABLES='iptables'
BFB_USE_REMOTE_IPTABLES_NFTABLES='iptables'
#------------------------------------------------------------------------------

BFB_BLOCK_REMOTE_SERVER='no'
BFB_BLOCK_USE_IPV6='no'
BFB_MONITOR_ONLY_LOCAL_SERVER='yes'
BFB_BLOCK_REMOTE_SERVER_IP='1.1.1.1'
BFB_BLOCK_REMOTE_SERVER_PORT='22'
BFB_BLOCK_REMOTE_SERVER_USE_OWN_COMMAND='no'
BFB_BLOCK_REMOTE_SERVER_USER='root'
BFB_BLOCK_REMOTE_FORWARD_CHAIN='PORTFWACCESS'
BFB_BLOCK_REMOTE_SSH_KEY=''
BFB_BLOCK_REMOTE_SERVER_PASSWD=''
BFB_BLOCK_REMOTE_SERVER_OWN_COMMAND=''
BFB_SEND_ATTACKER_TO_TWITTER='no'
BFB_MONITOR_MINI_HTTP='no' # monitor mini_http_server yes/no
BFB_MONITOR_FTPD='no' # monitor pure-ftp hack logins yes/no
BFB_USE_OWN_FTPD_LOGFILES='no'
BFB_MONITOR_MAIL='no' # monitor wrong logins for imap service
BFB_USE_OWN_MAIL_LOGFILES='no'
BFB_MAIL_LOGFILE='/var/log/messages' # logfile from MAIL
BFB_MAILMAIN_LOGFILE='/var/spool/exim/log/mainlog' # mainlogfile from mail
BFB_MONITOR_SN='no' # monitor wrong logins for newsserver service
BFB_USE_OWN_SN_LOGFILES='no'
BFB_SN_LOGFILE='/var/log/messages' # logfile from SN
BFB_MONITOR_BOT_ATTACK='yes'
BFB_MONITOR_SLOW_ATTACK='yes'
BFB_MONITOR_SSH_NEGOTIATE_ERRORS='yes'
BFB_MONITOR_BOT_ATTACK_ATTEMPTS='30'  # Number of attempts to block
BFB_MONITOR_TELNET='no'		# monitor Telnet logins
BFB_BOT_FREE_IP_ADDRESS_N='1'
BFB_BOT_FREE_IP_ADDRESS_1='192.168.10.3'
BFB_BOT_FREE_IP_ADDRESS_V6_N='1'
BFB_BOT_FREE_IP_ADDRESS_V6_1='fe80::201:80ff:fe05:520b'
BFB_BOT_FREE_IP_NET='192.168.10.0/24'
BFB_BOT_FREE_IP_NET_V6='fd0c:1ba0:4010:be01::/64'
BFB_USE_OWN_AUTH_LOGFILES='no'
BFB_MONITOR_SMBWEBCLIENT='no' # monitor logins for smbwebclient service
BFB_USE_OWN_SMBWEB_LOGFILES='no'
BFB_SMBWEBCLIENT_LOGFILE='/var/log/messages' # logfile from smbwebclient
BFB_MONITOR_PORTSCAN='yes' # check portscan
BFB_PORTSCAN_RANGES_N='5' # number of check portranges
BFB_PORTSCAN_RANGE_1='89:100' # portrange
BFB_PORTSCAN_RANGE_2='82:87'
BFB_PORTSCAN_RANGE_3='54:78'
BFB_PORTSCAN_RANGE_4='38:52'
BFB_PORTSCAN_RANGE_5='0:19'
BFB_USE_OWN_KERNEL_LOGFILES='no'
BFB_SERVER_RUN_AS_SYSLOGSERVER='no' # run this eisfairserver as syslogserver? yes/no
BFB_MONITOR_SPECIFIC_PORT='no' # block ip address to scan specificed Port
BFB_SPECIFIC_PORTS_N='1'
BFB_SPECIFIC_1_PORTS='135' # put your 1.port
BFB_EXTERNAL_INTERFACE='eth0' # interface for externel traffic
BFB_SERVER_SYSLOGSERVER_HOSTNAME='eis' # the hostname from your local server
BFB_MONITOR_BREAKIN_ATTEMPT='no' # monitor POSSIBLE BREAKIN ATTEMPT in syslog yes/no
BFB_MONITOR_SSH_VIA_IPTABLES='no'   # monitor ssh access via iptables and not via BFB-script
BFB_SSH_BLOCKTIME_VIA_IPTABLES='120' # block time attacker ip address in seconds
BFB_CHECK_FOR_NEW_VERSION='no'
BFB_CHECK_NEW_VERSION_CRON=$FIRST2' * * *'
BFB_CHECK_NEW_VERSION_TO_ADDRESS='root@localhost'
BFB_CHECK_NEW_VERSION_FROM_ADDRESS='root@loalhost'
BFB_WAITTIME='10' # time to wait for restart monitoring

#------------------------------------------------------------------------------
BFB_MONITOR_WEBACCESS='no' # monitor apache2 webserver for htassess-hack yes/no
BFB_USE_OWN_APACHE2_LOGFILES='no'
BFB_APACHE2_ACCESS_LOGFILE='/var/log/messages' # accesslogfile from apache
BFB_APACHE2_ERROR_LOGFILE='/var/log/messages' # errorlogfile from apache
BFB_MONITOR_UNAUTHORIZED='yes' # Monitor unauthorized webaccess 401
BFB_APACHE_USE_404_IGNORE_LIST='yes'
BFB_REQUEST_BLOCKS_VIA_WEBSERVER='no' # display to website yes/no
BFB_USE_APACHE_VERSION='2' # Do you use Apache 1 or 2
BFB_APACHE_DOCUMENTROOT='/var/www/htdocs' # root from Apache webservers
BFB_HTML_INDEX_FOLDER='brute_force_blocking' # html folder for index.html and IP.html
BFB_CGI_BIN_DOCUMENTROOT='/var/www/cgi-bin' # cgi-bin-root from Apache webserver
BFB_HTML_REFRESH_PATH='./cgi-bin/brute_force_blocking.cgi' # the refresh path for automatic reload from html to cgi file
BFB_OWN_WEBDOMAIN_NAME='http://localhost' # your own domainname to see bfb-html
BFB_SHOW_ATTACK_DETAILS_ON_WEB='yes' # show traceroute and whois printout on webserver
BFB_WEBSERVER_LOGFILE_CLEAR='1 0 * * *' # Time to clear the web log
#------------------------------------------------------------------------------
BFB_ATTACK_TIMES='6' # Number after many attempts the IP address blocked becomes
BFB_BLOCK_TYPE='REJECT' # type of blocking REJECT or DROP
BFB_MAX_BLOCKING_TIME='no'
BFB_MAX_BLOCKING_TIME_MINUTES='30'
BFB_FREE_IP='127.0.0.1 192.168.10.9' # never to block ip adresses
BFB_FREE_IPV6='fe80::201:80ff:fe05:520b'
BFB_FREE_IP_GROUP_N='0' # Number of Free ip address network or ip adresses
BFB_FREE_IP_GROUP_1='' # never to block ip adress group like 192.168.0.1-192.168.0.10
BFB_FREE_IP6_GROUP_N='0' # Number of Free ip address network or ip adresses
BFB_FREE_IP6_GROUP_1='' # never to block ip adress group like fd00:1a0:4222:ba11::/64
BFB_FREE_LAN_DOMAIN='' # never to block domain like router.home.lan
BFB_FREE_DYNDNS_DOMAIN='no' # never block a dyndns domain
BFB_FREE_DYNDNS_DOMAIN_N='0' # numbers of dyndns hosts
BFB_FREE_DYNDNS_DOMAIN_1='my.dyndns.tdl' # DYNDNS hosts
BFB_FREE_DYNDNS_UPDATE_ADDR_CRON='*/10 * * * *' # crontab for update
BFB_UNBLOCK_ALL_TIME='1 1 * * *' # Time to deblock blocked ip adresses
BFB_RESTART_ON_UNBLOCK='no' # restart BFB after deblock blocked ip addresses yes/no
BFB_RESOLVE_DNS='no' # resolve DNS from blocked IP yes/no

#------------------------------------------------------------------------------
BFB_WRITE_LOGENTRY_AFTER_ATTEMPTS='yes' # enable log to write attemps into logfile
BFB_EXTENDED_LOG_TO_MESSAGELOG='no' # log all attack-tries in /var/log/messages after block? yes/no
BFB_MESSAGE_LOGLEVEL='debug' #loglevel to log Attackes in messagelog
BFB_SEND_MAIL='no' # send email for detected attack yes/no
BFB_MAIL_TO_ADDRESS='root@localhost' # reciever email address
BFB_MAIL_FROM_ADDRESS='root@localhost' # sender email address
BFB_MAIL_SUBJECT='brute force attack detected' # own text for email subject
BFB_MAIL_WITH_WHOIS_REQUEST='yes' # send a email with the whois request from the attacker
BFB_MAIL_WITH_TRACEROUTE_REQUEST='yes' # send a email with a traceroute request from the attacker
BFB_ALL_INFO_IN_SAME_MAIL='yes' # end traceroute,whois and service in the same eMail
BFB_WRITE_ATTACK_TO_TXTFILE='no' # send all information from attack to an textfile
BFB_ATTACK_TXTFILE_FILENAME='/home/eis/attackfile' # the textfile for save all attack informations
BFB_ATTACK_FILE_CLEAR_CRON='1 0 1 * *' # clear the textfile via crontab

#------------------------------------------------------------------------------
BFB_SEND_VIA_CURL='no' # send a status message with curl
BFB_CURL_USERNAME='' # curl account
BFB_CURL_PASSWORD='' # curl password
BFB_CURL_TEXT='brute force attack detected from' # curl text
BFB_CURL_ADDRESS='http://twitter.com/statuses/update.xml' # twitter text

#------------------------------------------------------------------------------
BFB_RUN_COMMAND='no'
BFB_RUN_COMMAND_N='1'
BFB_RUN_COMMAND_1='/usr/bin/send-telegram-message.sh --peer PEER --msg "BFB-attack detected from ${ip} on ${service}"'

#------------------------------------------------------------------------------
BFB_SEND_TO_TWITTER='no'
BFB_TWITTER_USERNAME=''
BFB_TWITTER_TEXT='brute force attack detected from'

#------------------------------------------------------------------------------
BFB_MONITOR_ADDITIONAL_LOG='no' # monitor other logfile? yes/no
BFB_ADDITIONAL_LOG_SCRIPT='/dein/eigenes/bfb-script'  # der komplette Pfad zu dem Script

#------------------------------------------------------------------------------
BFB_BLOCK_PROACTIVE_FROM_ATMA='no' # block dangerous ip addresses are listed by atma.es
BFB_BLOCK_PROACTIVE_CRON=$FIRST' * * *' # cron to update atma.es list
BFB_BLOCK_PROACTIVE_FROM_DATABASE='no' # Block ip address proactiv from database
BFB_DAY_TO_CLEAR_PROACTIVE_DATABASE='30' # clear entries older than days in database
#------------------------------------------------------------------------------
BFB_MONITOR_OWNCLOUD='no'
BFB_OWNCLOUD_LOG_DIR='/var/owncloud/log'
BFB_MONITOR_NEXTCLOUD='no'
BFB_NEXTCLOUD_LOG_DIR='/var/nextcloud/log'
#------------------------------------------------------------------------------
BFB_BLOCK_AGGRESSIVE_IP4='' #Block very aggressive ip addresses
BFB_BLOCK_AGGRESSIVE_IP6='' #Block very aggressive ip addresses
#------------------------------------------------------------------------------
BFB_MONITOR_CRYPTOTROJANER='no'
BFB_USE_OWN_CRYPTOTROJANER_LOGFILE='no'
BFB_CRYPTOTROJANER_LOGFILE='/var/log/messages'

### ---------------------------------------------------------------------------
### read old configuration and rename old variables
### ---------------------------------------------------------------------------
read_old_variables()
{
 # read old values
 ### owncloud Data_dir importieren
 if [ -f /etc/config.d/owncloud ]
 then
     BFB_OWNCLOUD_DATA_DIR=`grep -m 1 "^OWNCLOUD_DATA_DIR" /etc/config.d/owncloud | \
                            sed 's/^OWNCLOUD_DATA_DIR[^/]*\([a-z0-9/_-]*\).*$/\1/'`

     if [ -z "${BFB_OWNCLOUD_DATA_DIR}" ]
     then
         BFB_OWNCLOUD_DATA_DIR='/var/owncloud/log'
     fi
 fi

 if [ -f /etc/config.d/nextcloud ]
 then
     grep -q "^OWNCLOUD_DATA_DIR" /etc/config.d/nextcloud

     if [ $? -eq 0 ]
     then
         BFB_NEXTCLOUD_LOG_DIR=`grep -m 1 "^OWNCLOUD_DATA_DIR" /etc/config.d/nextcloud | \
                                 sed 's/^OWNCLOUD_DATA_DIR[^/]*\([a-z0-9/_-]*\).*$/\1/'`
     else
         BFB_NEXTCLOUD_LOG_DIR=`grep -m 1 "^NEXTCLOUD_DATA_DIR" /etc/config.d/nextcloud | \
                                 sed 's/^NEXTCLOUD_DATA_DIR[^/]*\([a-z0-9/_-]*\).*$/\1/'`
     fi

     if [ -z "${BFB_NEXTCLOUD_LOG_DIR}" ]
     then
         BFB_NEXTCLOUD_LOG_DIR='/var/nextcloud/log'
     fi
     if [ -z "${BFB_OWNCLOUD_LOG_DIR}" ]
     then
         BFB_OWNCLOUD_LOG_DIR='/var/nextcloud/log'
     fi
 fi

 if [ -f /etc/config.d/apache2 ]
 then 
     . /etc/config.d/apache2
     BFB_APACHE_DOCUMENTROOT=$APACHE2_DOCUMENT_ROOT
     BFB_CGI_BIN_DOCUMENTROOT=$APACHE2_SCRIPT_DIR
 fi
 if [ -f /etc/config.d/$package ]
 then
     . /etc/config.d/$package
 fi
 if [ -f /etc/default/$package ]
 then
     . /etc/default/$package
 fi

}


#------------------------------------------------------------------------
# modify variables
#------------------------------------------------------------------------

modify_variables ()
{
 if [ -f /etc/config.d/${package_name} ]
 then
     configfile=/etc/config.d/${package_name}
 else 
     configfile=/etc/default/${package_name}
 fi
 if [ -f $configfile ]
 then    
     ### adding new variables
     if ! grep -q BFB_BLOCK_PROACTIVE_FROM_ATMA $configfile
     then
         echo 'adding new BFB_BLOCK_PROACTIVE_FROM_ATMA variable'
         echo 'adding new BFB_BLOCK_PROACTIVE_CRON variable'
     fi

     if ! grep -q BFB_MONITOR_SSH_NEGOTIATE_ERRORS $configfile
     then
         echo 'BFB_MONITOR_SSH_NEGOTIATE_ERRORS'
     fi

     if ! grep -q BFB_CHECK_FOR_NEW_VERSION $configfile
     then
         echo 'adding new BFB_CHECK_FOR_NEW_VERSION variable' 
         echo 'adding new BFB_CHECK_NEW_VERSION_CRON variable'
         echo 'adding new BFB_CHECK_NEW_VERSION_TO_ADDRESS variable'
         echo 'adding new BFB_CHECK_NEW_VERSION_FROM_ADDRESS variable'
     fi
     if ! grep -q BFB_APACHE_USE_404_IGNORE_LIST $configfile
     then
         echo 'adding new BFB_APACHE_USE_404_IGNORE_LIST variable'
     fi
     if ! grep -q BFB_MONITOR_UNAUTHORIZED $configfile
     then
         echo 'adding new BFB_MONITOR_UNAUTHORIZED variable'
     fi
     if ! grep -q BFB_MAIL_FROM_ADDRESS $configfile
     then
         echo 'adding new BFB_MESSAGE_LOGLEVEL variable'
         echo 'adding new BFB_MAIL_FROM_ADDRESS variable'
     fi
     ### modify variables
     if grep -q BFB_NEXTCLOUD_DATA_DIR $configfile
     then
         BFB_NEXTCLOUD_LOG_DIR=${BFB_NEXTCLOUD_DATA_DIR}
     fi
     if grep -q BFB_OWNCLOUD_DATA_DIR $configfile
     then
         BFB_OWNCLOUD_LOG_DIR=${BFB_OWNCLOUD_DATA_DIR}
     fi
     if grep -q BFB_MAIL_ADDRESS $configfile
     then
         BFB_MAIL_TO_ADDRESS=${BFB_MAIL_ADDRESS}
         echo 'changing BFB_MAIL_ADDRESS -> BFB_MAIL_TO_ADDRESS'
     fi
     if grep -q BRUTE_FORCE_BLOCKING_START $configfile
     then
         START_BRUTE_FORCE_BLOCKING=${BRUTE_FORCE_BLOCKING_START}
         echo 'changing BRUTE_FORCE_BLOCKING_START -> START_BRUTE_FORCE_BLOCKING'
     fi
     if grep -q BRUTE_FORCE_BLOCKING_ANZAHL $configfile
     then
         BFB_ATTACK_TIMES=${BRUTE_FORCE_BLOCKING_ANZAHL}
         echo 'changing BRUTE_FORCE_BLOCKING_ANZAHL -> BFB_ATTACK_TIMES'
     fi
     if grep -q BRUTE_FORCE_WEBSERVER_ROOT $configfile
     then
         BFB_APACHE_DOCUMENTROOT=${BRUTE_FORCE_WEBSERVER_ROOT}
         echo 'changing BRUTE_FORCE_WEBSERVER_ROOT -> BFB_APACHE_DOCUMENTROOT'
     fi
     if grep -q BRUTE_FORCE_ABFRAGE_VIA_WEBSERVER $configfile
     then
         BFB_REQUEST_BLOCKS_VIA_WEBSERVER=${BRUTE_FORCE_ABFRAGE_VIA_WEBSERVER}
         echo 'changing BRUTE_FORCE_ABFRAGE_VIA_WEBSERVER ->BFB_REQUEST_BLOCKS_VIA_WEBSERVER'
     fi
     if grep -q BRUTE_FORCE_BLOCKING_FREE_GROUP $configfile
     then
         BFB_FREE_IP_GROUP_1=${BRUTE_FORCE_BLOCKING_FREE_GROUP}
         echo 'changing BRUTE_FORCE_BLOCKING_FREE_GROUP -> BFB_FREE_IP_GROUP_1'
     fi
     if grep -wq BFB_FREE_IP_GROUP $configfile
     then
         BFB_FREE_IP_GROUP_1=${BFB_FREE_IP_GROUP}
         echo 'adding BFB_FREE_IP_GROUP_N variable'
         echo 'changing BFB_FREE_IP_GROUP -> BFB_FREE_IP_GROUP_1'
         if [ "$BFB_FREE_IP_GROUP_1" != "" ]
         then
             BFB_FREE_IP_GROUP_N='1'
         else
             BFB_FREE_IP_GROUP_N='0'
         fi
         BFB_FREE_IP_GROUP_1=${BFB_FREE_IP_GROUP}
     fi
     if grep -q BRUTE_FORCE_BLOCK_PURE $configfile
     then
         BFB_MONITOR_FTPD=${BRUTE_FORCE_BLOCK_PURE}
         echo 'changing BRUTE_FORCE_BLOCK_PURE -> BFB_MONITOR_FTPD'
     fi
     if [ "$BRUTE_FORCE_BLOCKING_USE_OWN_LOGFILES" = "yes" ]
     then
         BFB_USE_OWN_FTPD_LOGFILES='yes'
         BFB_USE_OWN_MAIL_LOGFILES='yes'
         BFB_USE_OWN_SN_LOGFILES='yes'
         BFB_USE_OWN_AUTH_LOGFILES='yes'
         BFB_USE_OWN_SMBWEBCLIENT_LOGFILES='yes'
         BFB_USE_OWN_KERNEL_LOGFILES='yes'
         echo 'changing BRUTE_FORCE_BLOCKING_USE_OWN_LOGFILES -> BFB_USE_OWN_FTPD_LOGFILES'
         echo 'changing BRUTE_FORCE_BLOCKING_USE_OWN_LOGFILES -> BFB_USE_OWN_MAIL_LOGFILES'
         echo 'changing BRUTE_FORCE_BLOCKING_USE_OWN_LOGFILES -> BFB_USE_OWN_SN_LOGFILES'
         echo 'changing BRUTE_FORCE_BLOCKING_USE_OWN_LOGFILES -> BFB_USE_OWN_AUTH_LOGFILES'
         echo 'changing BRUTE_FORCE_BLOCKING_USE_OWN_LOGFILES -> BFB_USE_OWN_SMBWEBCLIENT_LOGFILES'
         echo 'changing BRUTE_FORCE_BLOCKING_USE_OWN_LOGFILES -> BFB_USE_OWN_KERNEL_LOGFILES'
     fi
     if grep -q BRUTE_FORCE_USE_RAMDISK $configfile
     then
         BFB_USE_RAMDISK=${BRUTE_FORCE_USE_RAMDISK}
         BFB_MONITOR_MINI_HTTP=${BRUTE_FORCE_BLOCKING_MINI_HTTP}
         BFB_MONITOR_FTPD=${BRUTE_FORCE_BLOCK_FTPD}
         BFB_FTPD_LOGFILE=${BRUTE_FORCE_BLOCKING_FTPD_LOG}
         BFB_MONITOR_IMAP=${BRUTE_FORCE_BLOCK_IMAP}
         BFB_IMAP_LOGFILE=${BRUTE_FORCE_BLOCKING_IMAP_LOG}
         BFB_MONITOR_SN=${BRUTE_FORCE_BLOCK_SN}
         BFB_SN_LOGFILE=${BRUTE_FORCE_BLOCKING_SN_LOG}
         BFB_UNBLOCK_ALL_TIME=${BRUTE_FORCE_BLOCKING_RESTORE_TIME}
         BFB_AUTH_LOGFILE=${BRUTE_FORCE_BLOCKING_AUTH_LOG}
         if grep -q BRUTE_FORCE_BLOCKING_USE_OWN_FTPD_LOGFILES $configfile
         then
             BFB_USE_OWN_FTPD_LOGFILES=${BRUTE_FORCE_BLOCKING_USE_OWN_FTPD_LOGFILES}
             BFB_USE_OWN_MAIL_LOGFILES=${BRUTE_FORCE_BLOCKING_USE_OWN_IMAP_LOGFILES}
             BFB_USE_OWN_SN_LOGFILES=${BRUTE_FORCE_BLOCKING_USE_OWN_SN_LOGFILES}
             BFB_USE_OWN_AUTH_LOGFILES=${BRUTE_FORCE_BLOCKING_USE_OWN_AUTH_LOGFILES}
             BFB_USE_OWN_SMBWEBCLIENT_LOGFILES=${BRUTE_FORCE_BLOCKING_USE_OWN_SMBWEB_LOGFILES}
             BFB_USE_OWN_KERNEL_LOGFILES=${BRUTE_FORCE_BLOCKING_USE_OWN_KERNEL_LOGFILES}
         else
             BFB_USE_OWN_FTPD_LOGFILES=${BRUTE_FORCE_BLOCKING_USE_OWN_LOGFILES}
             BFB_USE_OWN_MAIL_LOGFILES=${BRUTE_FORCE_BLOCKING_USE_OWN_LOGFILES}
             BFB_USE_OWN_SN_LOGFILES=${BRUTE_FORCE_BLOCKING_USE_OWN_LOGFILES}
             BFB_USE_OWN_AUTH_LOGFILES=${BRUTE_FORCE_BLOCKING_USE_OWN_LOGFILES}
             BFB_USE_OWN_SMBWEBCLIENT_LOGFILES=${BRUTE_FORCE_BLOCKING_USE_OWN_LOGFILES}
             BFB_USE_OWN_KERNEL_LOGFILES=${BRUTE_FORCE_BLOCKING_USE_OWN_LOGFILES}
         fi
             BFB_MONITOR_SMBWEBCLIENT=${BRUTE_FORCE_BLOCK_SMBWEBCLIENT}
             BFB_SMBWEBCLIENT_LOGFILE=${BRUTE_FORCE_BLOCKING_SMBWEB_LOG}
             BFB_MONITOR_PORTSCAN=${BRUTE_FORCE_BLOCKING_BLOCK_PORTSCAN}
         if grep -q BRUTE_FORCE_BLOCKING_PORTSCAN_LOGLEVEL $configfile
         then
             BFB_LOGLEVEL=${BRUTE_FORCE_BLOCKING_PORTSCAN_LOGLEVEL}
             #BFB_MONITOR_CACTI=${BRUTE_FORCE_BLOCKING_MONITOR_CACTI}
             BFB_SERVER_RUN_AS_SYSLOGSERVER=${BRUTE_FORCE_BLOCKING_RUN_AS_SYSLOGSERVER} 
             BFB_PORTSCAN_RANGES_N=${BRUTE_FORCE_BLOCKING_PORTSCAN_RANGES_N}
             idxr=1
             while [ "$idxr" -le "$BFB_PORTSCAN_RANGES_N" ]
             do
                 eval range='$BRUTE_FORCE_BLOCKING_PORTSCAN_RANGE_'$idxr
                 eval 'BFB_PORTSCAN_RANGE_'$idxr=${range}
             idxr=`/usr/bin/expr $idxr + 1`
             done
             BFB_MONITOR_BOT_ATTACK=${BRUTE_FORCE_BLOCKING_BOT_ATTACK}
             BFB_BOT_FREE_IP_ADDRESS_N=${BRUTE_FORCE_BLOCKING_BOT_FREE_IP_ADDRESS_N}
             idxa=1
             while [ "$idxa" -le "$BFB_BOT_FREE_IP_ADDRESS_N" ]
             do
                 eval address='$BRUTE_FORCE_BLOCKING_BOT_FREE_IP_ADDRESS_'$idxa
                 eval 'BFB_BOT_FREE_IP_ADDRESS_'$idxa=$address
             idxa=`/usr/bin/expr $idxa + 1`
             done
             BFB_BOT_FREE_IP_NET=${BRUTE_FORCE_BLOCKING_BOT_FREE_NET}
         fi
         BFB_KERNEL_LOGFILE=${BRUTE_FORCE_BLOCKING_KERNEL_LOG}
         BFB_SERVER_SYSLOGSERVER_HOSTNAME=${BRUTE_FORCE_BLOCKING_SYSLOGSERVER_HOSTNAME}
         BFB_MONITOR_SPECIFIC_PORT=${BRUTE_FORCE_BLOCK_SPECIFIC_PORT}
         BFB_SPECIFIC_PORTS_N=${BRUTE_FORCE_BLOCK_SPECIFIC_PORTS_N}
         idxp=1
         while [ "$idxp" -le "$BFB_SPECIFIC_PORTS_N" ]
         do
             eval port='$BRUTE_FORCE_BLOCK_SPECIFIC_'$idxp'_PORTS'
             eval 'BFB_SPECIFIC_'$idxp'_PORTS'=$port
         idxp=`/usr/bin/expr $idxp + 1`
         done
         BFB_EXTERNAL_INTERFACE=${BRUTE_FORCE_EXTERNAL_INTERFACE}
         BFB_MONITOR_BREAKIN_ATTEMPT=${BRUTE_FORCE_CHECK_BREAKIN_ATTEMPT}
         BFB_MONITOR_WEBACCESS=${BRUTE_FORCE_BLOCK_WEB}
         if grep -q BRUTE_FORCE_REQUEST_VIA_WEBSERVER $configfile
         then
             BFB_REQUEST_BLOCKS_VIA_WEBSERVER=${BRUTE_FORCE_REQUEST_VIA_WEBSERVER}
         fi
         BFB_WRITE_ATTACK_TO_TXTFILE=${BRUTE_FORCE_BLOCKING_ATTACK_TO_TXT}
         BFB_ATTACK_TXTFILE_FILENAME=${BRUTE_FORCE_BLOCKING_ATTACK_TXT_FILE}
         BFB_USE_APACHE_VERSION=${BRUTE_FORCE_BLOCKING_USE_APACHE}
         if grep -q BRUTE_FORCE_APACHE_ROOT $configfile
         then
             BFB_APACHE_DOCUMENTROOT=${BRUTE_FORCE_APACHE_ROOT}
         fi
         BFB_HTML_INDEX_FOLDER=${BRUTE_FORCE_HTML_FOLDER}
         BFB_CGI_BIN_DOCUMENTROOT=${BRUTE_FORCE_WEBSERVER_CGI_BIN}
         BFB_HTML_REFRESH_PATH=${BRUTE_FORCE_HTML_REFRESH_PATH}
         BFB_OWN_WEBDOMAIN_NAME=${BRUTE_FORCE_BLOCKING_OWN_WEBDOMAIN}
         BFB_SHOW_ATTACK_DETAILS_ON_WEB=${BRUTE_FORCE_SHOW_DETAILS_ON_WEB}
         BFB_WEBSERVER_LOGFILE_CLEAR=${BRUTE_FORCE_WEBSERVER_LOG_CLEAR}
         if grep -q BRUTE_FORCE_BLOCKING_TIMES $configfile
         then
             BRUTE_FORCE_BLOCKING_TIMES=${BFB_ATTACK_TIMES}
         fi
         BFB_BLOCK_TYPE=${BRUTE_FORCE_BLOCK_TYPE}
         BFB_FREE_IP=${BRUTE_FORCE_BLOCKING_FREE_IP}

         if grep -q BRUTE_FORCE_BLOCKING_FREE_IP_GROUP $configfile
         then
             BFB_FREE_IP_GROUP_1=${BRUTE_FORCE_BLOCKING_FREE_IP_GROUP}
         fi
         BFB_FREE_LAN_DOMAIN=${BRUTE_FORCE_BLOCKING_FREE_LAN_DOMAIN}
         BFB_RESOLVE_DNS=${BRUTE_FORCE_REQUEST_DNS_RESOLVE}
         BFB_EXTENDED_LOG_TO_MESSAGELOG=${BRUTE_FORCE_LOG_MESSAGES}
         BFB_SEND_MAIL=${BRUTE_FORCE_BLOCKING_MAIL}
         BFB_MAIL_TO_ADDRESS=${BRUTE_FORCE_BLOCKING_MAILADDRESS}
         BFB_MAIL_SUBJECT=${BRUTE_FORCE_MAIL_SUBJECT}
         BFB_MAIL_WITH_WHOIS_REQUEST=${BRUTE_FORCE_MAIL_WITH_WHOIS_REQUEST}
         BFB_MAIL_WITH_TRACEROUTE_REQUEST=${BRUTE_FORCE_MAIL_WITH_TRACEROUTE_REQUEST}
         BFB_ALL_INFO_IN_SAME_MAIL=${BRUTE_FORCE_BLOCKING_SAME_MAIL}
         BFB_ATTACK_FILE_CLEAR_CRON=${BRUTE_FORCE_BLOCKING_ATTACK_FILE_CLEAR_CRON}
         BFB_SEND_VIA_CURL=${BRUTE_FORCE_BLOCKING_CURL}
         BFB_CURL_USERNAME=${BRUTE_FORCE_BLOCKING_CURLNAME}
         BFB_CURL_PASSWORD=${BRUTE_FORCE_BLOCKING_CURLPASS}
         BFB_CURL_TEXT=${BRUTE_FORCE_BLOCKING_CURLTEXT}
         BFB_CURL_ADDRESS=${BRUTE_FORCE_BLOCKING_CURLADDRESS}
         BFB_SMBWEBCLIENT_LOGFILE=${BRUTE_FORCE_BLOCKING_SMBWEB_LOG}

         echo 'changing BRUTE_FORCE_USE_RAMDISK -> BFB_USE_RAMDISK'
         echo 'changing BRUTE_FORCE_BLOCKING_MINI_HTTP -> BFB_MONITOR_MINI_HTTP'
         echo 'changing BRUTE_FORCE_BLOCK_FTPD -> BFB_MONITOR_FTPD'
         echo 'changing BRUTE_FORCE_BLOCKING_FTPD_LOG -> BFB_FTPD_LOGFILE'
         echo 'changing BRUTE_FORCE_BLOCK_IMAP -> BFB_MONITOR_MAIL'
         echo 'changing BRUTE_FORCE_BLOCKING_USE_OWN_IMAP_LOGFILES -> BFB_USE_OWN_MAIL_LOGFILES'
         echo 'changing BRUTE_FORCE_BLOCKING_IMAP_LOG -> BFB_MAIL_LOGFILE'
         echo 'changing BRUTE_FORCE_BLOCK_SN -> BFB_MONITOR_SN'
         echo 'changing BRUTE_FORCE_BLOCKING_USE_OWN_SN_LOGFILES -> BFB_USE_OWN_SN_LOGFILES'
         echo 'changing BRUTE_FORCE_BLOCKING_SN_LOG -> BFB_SN_LOGFILE'
         echo 'changing BRUTE_FORCE_BLOCKING_BOT_ATTACK -> BFB_MONITOR_BOT_ATTACK'
         echo 'changing BRUTE_FORCE_BLOCKING_BOT_FREE_IP_ADDRESS_N -> BFB_BOT_FREE_IP_ADDRESS_N'
         echo 'changing BRUTE_FORCE_BLOCKING_BOT_FREE_IP_ADDRESS_1 -> BFB_BOT_FREE_IP_ADDRESS_1'
         echo 'changing BRUTE_FORCE_BLOCKING_BOT_FREE_NET -> BFB_BOT_FREE_IP_NET'
         echo 'changing BRUTE_FORCE_BLOCKING_USE_OWN_AUTH_LOGFILES -> BFB_USE_OWN_AUTH_LOGFILES'
         echo 'changing BRUTE_FORCE_BLOCKING_AUTH_LOG -> BFB_AUTH_LOGFILE'
         echo 'changing BRUTE_FORCE_BLOCK_SMBWEBCLIENT -> BFB_MONITOR_SMBWEBCLIENT'
         echo 'changing BRUTE_FORCE_BLOCKING_USE_OWN_SMBWEB_LOGFILES -> BFB_USE_OWN_SMBWEBCLIENT_LOGFILES'
         echo 'changing BRUTE_FORCE_BLOCKING_SMBWEB_LOG -> BFB_SMBWEBCLIENT_LOGFILE'
         echo 'changing BRUTE_FORCE_BLOCKING_BLOCK_PORTSCAN -> BFB_MONITOR_PORTSCAN'
         echo 'changing BRUTE_FORCE_BLOCKING_PORTSCAN_RANGES_N -> BFB_PORTSCAN_RANGES_N'
         echo 'changing BRUTE_FORCE_BLOCKING_PORTSCAN_RANGE_% -> BFB_PORTSCAN_RANGE_%'
         echo 'changing BRUTE_FORCE_BLOCKING_PORTSCAN_LOGLEVEL -> BFB_LOGLEVEL'
         echo 'changing BRUTE_FORCE_BLOCKING_USE_OWN_KERNEL_LOGFILES -> BFB_USE_OWN_KERNEL_LOGFILES'
         echo 'changing BRUTE_FORCE_BLOCKING_KERNEL_LOG -> BFB_KERNEL_LOGFILE'
         echo 'changing BRUTE_FORCE_BLOCKING_RUN_AS_SYSLOGSERVER -> BFB_SERVER_RUN_AS_SYSLOGSERVER'
         echo 'changing BRUTE_FORCE_BLOCKING_SYSLOGSERVER_HOSTNAME -> BFB_SERVER_SYSLOGSERVER_HOSTNAME'
         echo 'changing BRUTE_FORCE_BLOCK_SPECIFIC_PORT -> BFB_MONITOR_SPECIFIC_PORT'
         echo 'changing BRUTE_FORCE_BLOCK_SPECIFIC_PORTS_N -> BFB_SPECIFIC_PORTS_N'
         echo 'changing BRUTE_FORCE_BLOCK_SPECIFIC_%_PORTS -> BFB_SPECIFIC_%_PORTS'
         echo 'changing BRUTE_FORCE_EXTERNAL_INTERFACE -> BFB_EXTERNAL_INTERFACE'
         echo 'changing BRUTE_FORCE_CHECK_BREAKIN_ATTEMPT -> BFB_MONITOR_BREAKIN_ATTEMPT'
         echo 'changing BRUTE_FORCE_BLOCK_WEB -> BFB_MONITOR_WEBACCESS'
         echo 'changing BRUTE_FORCE_REQUEST_VIA_WEBSERVER -> BFB_REQUEST_BLOCKS_VIA_WEBSERVER'
         echo 'changing BRUTE_FORCE_BLOCKING_USE_APACHE -> BFB_USE_APACHE_VERSION'
         echo 'changing BRUTE_FORCE_APACHE_ROOT -> BFB_APACHE_DOCUMENTROOT'
         echo 'changing BRUTE_FORCE_HTML_FOLDER -> BFB_HTML_INDEX_FOLDER'
         echo 'changing BRUTE_FORCE_WEBSERVER_CGI_BIN -> BFB_CGI_BIN_DOCUMENTROOT'
         echo 'changing BRUTE_FORCE_HTML_REFRESH_PATH -> BFB_HTML_REFRESH_PATH'
         echo 'changing BRUTE_FORCE_BLOCKING_OWN_WEBDOMAIN -> BFB_OWN_WEBDOMAIN_NAME'
         echo 'changing BRUTE_FORCE_SHOW_DETAILS_ON_WEB -> BFB_SHOW_ATTACK_DETAILS_ON_WEB'
         echo 'changing BRUTE_FORCE_WEBSERVER_LOG_CLEAR -> BFB_WEBSERVER_LOGFILE_CLEAR'
         echo 'changing BRUTE_FORCE_BLOCKING_TIMES -> BFB_ATTACK_TIMES'
         echo 'changing BRUTE_FORCE_BLOCK_TYPE -> BFB_BLOCK_TYPE_CUI'
         echo 'changing BRUTE_FORCE_BLOCKING_FREE_IP -> BFB_FREE_IP'
         echo 'changing BRUTE_FORCE_BLOCKING_FREE_IP_GROUP -> BFB_FREE_IP_GROUP_1'
         echo 'changing BRUTE_FORCE_BLOCKING_FREE_LAN_DOMAIN -> BFB_FREE_LAN_DOMAIN'
         echo 'changing BRUTE_FORCE_BLOCKING_RESTORE_TIME -> BFB_UNBLOCK_ALL_TIME'
         echo 'changing BRUTE_FORCE_REQUEST_DNS_RESOLVE -> BFB_RESOLVE_DNS'
         echo 'changing BRUTE_FORCE_LOG_MESSAGES -> BFB_EXTENDED_LOG_TO_MESSAGELOG'
         echo 'changing BRUTE_FORCE_BLOCKING_MAIL -> BFB_SEND_MAIL'
         echo 'changing BRUTE_FORCE_BLOCKING_MAILADDRESS -> BFB_MAIL_TO_ADDRESS'
         echo 'changing BRUTE_FORCE_MAIL_SUBJECT -> BFB_MAIL_SUBJECT'
         echo 'changing BRUTE_FORCE_MAIL_WITH_WHOIS_REQUEST -> BFB_MAIL_WITH_WHOIS_REQUEST'
         echo 'changing BRUTE_FORCE_MAIL_WITH_TRACEROUTE_REQUEST -> BFB_MAIL_WITH_TRACEROUTE_REQUEST'
         echo 'changing BRUTE_FORCE_BLOCKING_SAME_MAIL -> BFB_ALL_INFO_IN_SAME_MAIL'
         echo 'changing BRUTE_FORCE_BLOCKING_ATTACK_TO_TXT -> BFB_WRITE_ATTACK_TO_TXTFILE'
         echo 'changing BRUTE_FORCE_BLOCKING_ATTACK_TXT_FILE -> BFB_ATTACK_TXTFILE_FILENAME'
         echo 'changing BRUTE_FORCE_BLOCKING_ATTACK_FILE_CLEAR_CRON -> BFB_ATTACK_FILE_CLEAR_CRON'
         echo 'changing BRUTE_FORCE_BLOCKING_CURL -> BFB_SEND_VIA_CURL'
         echo 'changing BRUTE_FORCE_BLOCKING_CURLNAME -> BFB_CURL_USERNAME'
         echo 'changing BRUTE_FORCE_BLOCKING_CURLPASS -> BFB_CURL_PASSWORD'
         echo 'changing BRUTE_FORCE_BLOCKING_CURLTEXT -> BFB_CURL_TEXT'
         echo 'changing BRUTE_FORCE_BLOCKING_CURLADDRESS -> BFB_CURL_ADDRESS'
     fi
     if grep -q BFB_USE_OWN_IMAP_LOGFILES $configfile
     then
         BFB_MAIL_LOGFILE=${BFB_IMAP_LOGFILE}
         BFB_USE_OWN_MAIL_LOGFILES=${BFB_USE_OWN_IMAP_LOGFILES}
         BFB_MONITOR_MAIL=${BFB_MONITOR_IMAP}
         echo 'changing BFB_IMAP_LOGFILE -> BFB_MAIL_LOGFILE'
         echo 'changing BFB_USE_OWN_IMAP_LOGFILES -> BFB_USE_OWN_MAIL_LOGFILES'
         echo 'changing BFB_MONITOR_IMAP -> BFB_MONITOR_MAIL'
     fi
     if grep -q BFB_PORTSCAN_LOGLEVEL $configfile
     then
         BFB_MESSAGE_LOGLEVEL=${BFB_LOGLEVEL}
         BFB_LOGLEVEL=${BFB_PORTSCAN_LOGLEVEL}
         echo 'changing BFB_LOGLEVEL -> BFB_MESSAGE_LOGLEVEL'
         echo 'changing BFB_PORTSCAN_LOGLEVEL -> BFB_LOGLEVEL'
     fi
     if grep -q BFB_UNBLOCK_TIME $configfile
     then
         BFB_UNBLOCK_ALL_TIME=${BFB_UNBLOCK_TIME}
         echo 'changing BFB_UNBLOCK_TIME -> BFB_UNBLOCK_ALL_TIME'
     fi
fi
}
### ---------------------------------------------------------------------------
### Write config and default files
### ---------------------------------------------------------------------------
make_config_file()
{
 internal_conf_file=${1}
 (
 #--------------------------------------------------------------------------------
 printgpl -conf ${package_name} ${DATUM} "OJae" "Olaf Jaehrling eisfair(at)ojaehrling(dot)de"
 #--------------------------------------------------------------------------------
 #--------------------------------------------------------------------------------
 printgroup "Brute Force Blocking common configuration"
 #--------------------------------------------------------------------------------
 printvar "START_BRUTE_FORCE_BLOCKING" "start brute_force_blocking yes/no"
 printvar "BFB_WAITTIME" "time to wait for restart monitoring"
 printvar "BFB_BLOCK_USE_IPV6" "is IPv6 insrtalled and use Eisfair IPv6?"
 printvar "BFB_BLOCK_REMOTE_SERVER" "block attack adress on foreign server yes/no"
 printvar "BFB_LOGLEVEL" "loglevel for kernel messages"
 printvar "BFB_USE_RAMDISK" "use RAMdisk for BFB yes/no"
 printvar "BFB_USE_IPTABLES_NFTABLES" "use iptables or nftables"
 printvar "BFB_RUN_IN_DEBUG_MODE"  "run BFB in debug mode"
 printvar "BFB_DEBUGLOG_CRON_LOGROTATE"  "interval to rotate debuglog"
 printvar "BFB_ATTACK_TIMES" "Number after many attempts the IP address blocked becomes"
 printvar "BFB_BLOCK_TYPE" "type of blocking REJECT or DROP"
 printvar "BFB_MAX_BLOCKING_TIME" "aktivate deblocking after many minutes?"
 printvar "BFB_MAX_BLOCKING_TIME_MINUTES" "Minutes after deblock ip address"
 printvar "BFB_UNBLOCK_ALL_TIME" "Time to deblock blocked ip adresses"
 printvar "BFB_RESTART_ON_UNBLOCK" "restart BFB after deblock blocked ip addresses yes/no"
 printvar "BFB_RESOLVE_DNS" "resolve DNS from blocked IP yes/no"
 printvar "BFB_CHECK_FOR_NEW_VERSION" "check for new BFB version via cronjob? yes/no"
 printvar "BFB_SEND_ATTACKER_TO_TWITTER" "send attacker ip to BFB-Twitteraccount for proactive blocking"

 #--------------------------------------------------------------------------------
 printgroup "Brute Force Blocking remote blocking "
 #--------------------------------------------------------------------------------
 printvar "BFB_BLOCK_REMOTE_SERVER_IP" "ip address of the firewall"
 printvar "BFB_USE_REMOTE_IPTABLES_NFTABLES" "use iptables or nftables on remote firewall"
 printvar "BFB_BLOCK_REMOTE_SERVER_PORT" "remote access port"
 printvar "BFB_BLOCK_REMOTE_FORWARD_CHAIN" "iptables chain for forwarding"
 printvar "BFB_BLOCK_REMOTE_SERVER_USE_OWN_COMMAND" "use own commands for blocking on foreign server"
 printvar "BFB_BLOCK_REMOTE_SERVER_OWN_COMMAND" "your command or script for blocking on the foreign server"
 printvar "BFB_BLOCK_REMOTE_SERVER_USER" "username for putty access with root privileg Default:root"
 printvar "BFB_BLOCK_REMOTE_SERVER_PASSWD" "password for User"
 printvar "BFB_BLOCK_REMOTE_SSH_KEY" "the putty-ssh key for User"

 #--------------------------------------------------------------------------------
 printgroup "Brute Force Blocking Monitor configuration"
 #--------------------------------------------------------------------------------
 printvar "BFB_MONITOR_MINI_HTTP" "monitor mini_http_server yes or no"
 printvar "BFB_MONITOR_FTPD" "monitor pure-ftp hack logins yes/no"
 printvar "BFB_MONITOR_MAIL" "monitor wrong logins for imap service"
 printvar "BFB_MONITOR_SN" "monitor wrong logins for newsserver service"
 printvar "BFB_MONITOR_PORTSCAN" "Monitor Logfile about portscans"
 printvar "BFB_MONITOR_BOT_ATTACK" "monitor ssh bot-attack"
 printvar "BFB_MONITOR_SLOW_ATTACK" "monitor slow bot-ssh-attacks"
 printvar "BFB_MONITOR_SSH_NEGOTIATE_ERRORS" "monitor Unable to negotiate no matching key exchange method found"
 printvar "BFB_MONITOR_SPECIFIC_PORT" "block ip addresses if this check specificed ports"
 printvar "BFB_SPECIFIC_PORTS_N" "Numbers of specificed ports"
 idx=1
 while [ "$idx" -le "$BFB_SPECIFIC_PORTS_N" ]
 do
     printvar 'BFB_SPECIFIC_'$idx'_PORTS' "Portnumber"
 idx=`/usr/bin/expr $idx + 1`
 done
 printvar "BFB_EXTERNAL_INTERFACE" "interface for externel traffic"
 printvar "BFB_MONITOR_BREAKIN_ATTEMPT" "monitor POSSIBLE BREAKIN ATTEMPT in syslog yes/no"
# printvar "BFB_MONITOR_CACTI" "monitor logins into cacti-tool yes/no"
 printvar "BFB_MONITOR_WEBACCESS" "monitor apache2 webserver for htassess-hack yes/no"
 printvar "BFB_MONITOR_UNAUTHORIZED" "monitor unauthorized webaccess"
 printvar "BFB_APACHE_USE_404_IGNORE_LIST" "ignore dummy files like favicon"
 printvar "BFB_MONITOR_SMBWEBCLIENT" "monitor logins for smbwebclient service"
 printvar "BFB_MONITOR_TELNET" "monitor telnet logins"
 printvar "BFB_MONITOR_CRYPTOTROJANER" "monitor syslogfile about copy cryptotrojanerfiles"
 printvar "BFB_MONITOR_OWNCLOUD" "monitor Owncloud login attemps?"
 printvar "BFB_MONITOR_NEXTCLOUD" "monitor Nextcloud login attemps?"
 printvar "BFB_MONITOR_ADDITIONAL_LOG" "monitor other logfile"
 printvar "BFB_MESSAGE_LOGLEVEL" "loglevel to log Attackes in messagelog"

 #--------------------------------------------------------------------------------
 printgroup "Brute Force Blocking free ip address configuration"
 #--------------------------------------------------------------------------------
 printvar "BFB_FREE_IP" "never to block ip adresses"
 printvar "BFB_FREE_IPV6" "never to block ipv6 adresses"
 printvar "BFB_FREE_IP_GROUP_N" "Number of Free ip address network or ip adresses"
 idxg=1
 while [ "$idxg" -le "$BFB_FREE_IP_GROUP_N" ]
 do
     printvar 'BFB_FREE_IP_GROUP_'$idxg "never to block ip adress group like 192.168.0.1-192.168.0.10"
 idxg=`/usr/bin/expr $idxg + 1`
 done
 printvar "BFB_FREE_LAN_DOMAIN" "never to block domain like router.home.lan"

 printvar "BFB_FREE_DYNDNS_DOMAIN" "never block a dyndns domain"
 printvar "BFB_FREE_DYNDNS_DOMAIN_N" "numbers of dyndns hosts"
 idxd=1
 while [ "$idxd" -le "$BFB_FREE_DYNDNS_DOMAIN_N" ]
 do
     printvar 'BFB_FREE_DYNDNS_DOMAIN_'$idxd "DYNDNS hosts"
 idxd=`/usr/bin/expr $idxd + 1`
 done
 printvar "BFB_FREE_DYNDNS_UPDATE_ADDR_CRON" "DYNDNS hosts"

 #--------------------------------------------------------------------------------
 printgroup "Brute Force Blocking BOT-Attack configuration"
 #--------------------------------------------------------------------------------
 printvar "BFB_MONITOR_BOT_ATTACK_ATTEMPTS" "Number of attempts to block"
 printvar "BFB_BOT_FREE_IP_NET" "network to allow ssh after bot-attack"
 printvar "BFB_BOT_FREE_IP_ADDRESS_N" "number of ip address to allow ssh after bot-attack"
 idxb=1
 while [ "$idxb" -le "$BFB_BOT_FREE_IP_ADDRESS_N" ]
 do
     printvar 'BFB_BOT_FREE_IP_ADDRESS_'$idxb "ip address to allow ssh after bot-attack"
 idxb=`/usr/bin/expr $idxb + 1`
 done
 printvar "BFB_BOT_FREE_IP_ADDRESS_V6_N" "number of ipv6 address to allow ssh after bot-attack"
 idxbb=1
 while [ "$idxbb" -le "$BFB_BOT_FREE_IP_ADDRESS_V6_N" ]
 do
     printvar 'BFB_BOT_FREE_IP_ADDRESS_V6_'$idxbb "ip v6 address to allow ssh after bot-attack"
 idxbb=`/usr/bin/expr $idxbb + 1`
 done
 printvar "BFB_BOT_FREE_IP_NET_V6" "network to allow ssh after bot-attack"

 #--------------------------------------------------------------------------------
 printgroup "Brute Force Blocking logfiles configuration"
 #--------------------------------------------------------------------------------
 printvar "BFB_WRITE_LOGENTRY_AFTER_ATTEMPTS" "enable log to write attemps into logfile"
 printvar "BFB_EXTENDED_LOG_TO_MESSAGELOG" "log all attack-tries in /var/log/messages after block? yes/no"
 printvar "BFB_USE_OWN_FTPD_LOGFILES" "use own logfiles for ftpd?"
 printvar "BFB_FTPD_LOGFILE" "logfile from PureFTPD"
 printvar "BFB_USE_OWN_MAIL_LOGFILES" "use own logfiles for imapd?"
 printvar "BFB_MAIL_LOGFILE" "logfile from MAIL"
 printvar "BFB_USE_OWN_SN_LOGFILES" "use own logfiles for sn?"
 printvar "BFB_SN_LOGFILE" "logfile from SN"
 printvar "BFB_USE_OWN_AUTH_LOGFILES" "use own logfiles for authentification?"
 printvar "BFB_AUTH_LOGFILE" "logfile for ssh logins"
 printvar "BFB_USE_OWN_SMBWEB_LOGFILES" "use own logfiles for smbwebclient?"
 printvar "BFB_SMBWEBCLIENT_LOGFILE" "logfile from smbwebclient"
 printvar "BFB_USE_OWN_KERNEL_LOGFILES" "use own logfiles for kernelmessages?"
 printvar "BFB_KERNEL_LOGFILE" "logfile for kernel messages"
 #printvar "BFB_USE_OWN_ASTERISK_LOGFILE" "use own asterisk logfile?"
 #printvar "BFB_ASTERISK_LOGFILE" "logfile for asterisk messages"
 printvar "BFB_USE_OWN_CRYPTOTROJANER_LOGFILE" "use own logfile for syslog messages?"
 printvar "BFB_CRYPTOTROJANER_LOGFILE" "logfile for syslog messages"

 #--------------------------------------------------------------------------------
 printgroup "Brute Force Blocking portscan configuration"
 #--------------------------------------------------------------------------------
 printvar "BFB_PORTSCAN_RANGES_N" "number of portrange"
 idxpr=1
 while [ "$idxpr" -le "$BFB_PORTSCAN_RANGES_N" ]
 do
     printvar 'BFB_PORTSCAN_RANGE_'$idxpr "portrange"
 idxpr=`/usr/bin/expr $idxpr + 1`
 done
 #--------------------------------------------------------------------------------
 printgroup "Brute Force Blocking syslog-server configuration"
 #--------------------------------------------------------------------------------
 printvar "BFB_SERVER_RUN_AS_SYSLOGSERVER" "run this eisfairserver as syslogserver? yes/no"
 printvar "BFB_MONITOR_ONLY_LOCAL_SERVER" "BFB will be monitor only the local server"
 printvar "BFB_SERVER_SYSLOGSERVER_HOSTNAME" "the hostname from your local server"

 #------------------------------------------------------------------------------
 printgroup "Brute Force Blocking webserver configuration"
 #--------------------------------------------------------------------------------
 printvar "BFB_REQUEST_BLOCKS_VIA_WEBSERVER" "display to website yes/no"
 printvar "BFB_USE_APACHE_VERSION" "Do you use Apache 1 or 2"
 printvar "BFB_APACHE_DOCUMENTROOT" "root from Apache webservers"
 printvar "BFB_HTML_INDEX_FOLDER" "html folder for index.html and IP.html"
 printvar "BFB_CGI_BIN_DOCUMENTROOT" "cgi/bin-root from Apache webserver"
 printvar "BFB_HTML_REFRESH_PATH" "the refresh path for automatic reload from html to cgi file"
 printvar "BFB_OWN_WEBDOMAIN_NAME" "your own domainname to see bfb html"
 printvar "BFB_SHOW_ATTACK_DETAILS_ON_WEB" "show traceroute and whois printout on webserver"
 printvar "BFB_WEBSERVER_LOGFILE_CLEAR" "Time to clear the web log"

 #------------------------------------------------------------------------------
 printgroup "Brute Force Blocking additional logfile configuration"
 #------------------------------------------------------------------------------
 printvar "BFB_ADDITIONAL_LOG_SCRIPT" "the complete path to your own bfb-script"

 #------------------------------------------------------------------------------
 printgroup "Brute Force Blocking block proactive configuration"
 printvar "BFB_BLOCK_PROACTIVE_FROM_ATMA" "block dangerous ip addresses are listed by atma.es"
 printvar "BFB_BLOCK_PROACTIVE_CRON" "cron to update atma.es list"
 printvar "BFB_BLOCK_PROACTIVE_FROM_DATABASE" "Block ip address proactiv from database"
 printvar "BFB_DAY_TO_CLEAR_PROACTIVE_DATABASE" "clear entries older than days in database"
 printvar "BFB_BLOCK_AGGRESSIVE_IP4" "Block very aggressive ipv4 addresses"
 printvar "BFB_BLOCK_AGGRESSIVE_IP6" "Block very aggressive ipv6 addresses"

 #------------------------------------------------------------------------------
 printgroup "Brute Force Blocking information configuration"
 #--------------------------------------------------------------------------------
 printvar "BFB_SEND_MAIL" "send email for detected attack yes/no"
 printvar "BFB_MAIL_TO_ADDRESS" "reciever email address"
 printvar "BFB_MAIL_FROM_ADDRESS" "sender email address"
 printvar "BFB_MAIL_SUBJECT" "own text for email subject"
 printvar "BFB_MAIL_WITH_WHOIS_REQUEST" "send a email with the whois request from the attacker"
 printvar "BFB_MAIL_WITH_TRACEROUTE_REQUEST" "send a email with a traceroute request from the attacker"
 printvar "BFB_ALL_INFO_IN_SAME_MAIL" "send traceroute,whois and service in the same eMail"
 printvar "BFB_WRITE_ATTACK_TO_TXTFILE" "send all information from attack to an textfile"
 printvar "BFB_ATTACK_TXTFILE_FILENAME" "the textfile for save all attack informations"
 printvar "BFB_ATTACK_FILE_CLEAR_CRON" "clear the textfile via crontab"
 printvar "BFB_SEND_VIA_CURL" "send a status message with curl"
 printvar "BFB_SEND_TO_TWITTER" "send a status message to your Twitter account"
 printvar "BFB_RUN_COMMAND" "send command after detect an attack"

 #------------------------------------------------------------------------------
 printgroup "Brute Force Blocking Command configuration"
 #--------------------------------------------------------------------------------

 printvar "BFB_RUN_COMMAND_N" "number of commands"
 idxc=1
 while [ "$idxc" -le "$BFB_RUN_COMMAND_N" ]
 do
     printvar 'BFB_RUN_COMMAND_'$idxc "command"
     idxc=`/usr/bin/expr $idxc + 1`
 done

 #------------------------------------------------------------------------------
 printgroup "Brute Force Blocking Curl configuration"
 #--------------------------------------------------------------------------------
 printvar "BFB_CURL_USERNAME" "curl account"
 printvar "BFB_CURL_PASSWORD" "curl password"
 printvar "BFB_CURL_TEXT" "curl text"
 printvar "BFB_CURL_ADDRESS" "the url where to send to, eg: http://twitter.com/statuses/update.xml"

 #------------------------------------------------------------------------------
 printgroup "Brute Force Blocking Twitter configuration"
 #--------------------------------------------------------------------------------
 printvar "BFB_TWITTER_USERNAME" "Twitter Account"
 printvar "BFB_TWITTER_TEXT" "Text to send to Twitter"


 #------------------------------------------------------------------------------
 printgroup "Brute Force Blocking Cacti configuration"
 #--------------------------------------------------------------------------------
# printvar "BFB_CACTI_SERVER_IP_ADDRESS" "ip adress to running the mysql server from cacti tool"
# printvar "BFB_CACTI_WEB_ROOT" "cacti Data Directory"
 #--------------------------------------------------------------------------------

 #------------------------------------------------------------------------------
 printgroup "Brute Force Blocking Check new Version "
 #--------------------------------------------------------------------------------
 printvar "BFB_CHECK_NEW_VERSION_CRON" "cronjob for new versionscheck"
 printvar "BFB_CHECK_NEW_VERSION_TO_ADDRESS" "email address to send information about new Version"
 printvar "BFB_CHECK_NEW_VERSION_FROM_ADDRESS" "sender email address for new version"
 #------------------------------------------------------------------------------

 #------------------------------------------------------------------------------
 printgroup "Brute Force Blocking Own/Nextcloud configuration"
 #------------------------------------------------------------------------------
 printvar "BFB_OWNCLOUD_LOG_DIR" "Owncloud Data Directory"
 printvar "BFB_NEXTCLOUD_LOG_DIR" "Nextcloud Data Directory"
 #------------------------------------------------------------------------------

 printend
 #--------------------------------------------------------------------------------

 ) > ${internal_conf_file}
 # Set rights
 chmod 0600 ${internal_conf_file}
 chown root ${internal_conf_file}
}

### -------------------------------------------------------------------------
### Create the check.d file
### -------------------------------------------------------------------------

make_check_file()
{
#--------------------------------------------------------------------------------
printgpl -check ${package_name} ${DATUM} "OJae" "Olaf Jaehrling <eisfair[at]ojaehrling[dot]de>" >/etc/check.d/${package}
#--------------------------------------------------------------------------------
cat >>/etc/check.d/${package} <<EOF
# Variable OPT_VARIABLE VARIABLE_N VALUE
START_BRUTE_FORCE_BLOCKING          -                               -                 YESNO
+BFB_WAITTIME		           START_BRUTE_FORCE_BLOCKING       -                 BFB_WAITTIME_CUI
+BFB_RUN_IN_DEBUG_MODE             START_BRUTE_FORCE_BLOCKING       -                 YESNO
+BFB_DEBUGLOG_CRON_LOGROTATE	   BFB_RUN_IN_DEBUG_MODE	    -                 NONE
BFB_BLOCK_USE_IPV6                 START_BRUTE_FORCE_BLOCKING       -                 YESNO
BFB_BLOCK_REMOTE_SERVER            START_BRUTE_FORCE_BLOCKING       -                 YESNO
BFB_USE_IPTABLES_NFTABLES          START_BRUTE_FORCE_BLOCKING       -                 BFBTABLES_CUI
BFB_USE_REMOTE_IPTABLES_NFTABLES   BFB_BLOCK_REMOTE_SERVER          -                 BFBTABLES_CUI
BFB_MAX_BLOCKING_TIME              START_BRUTE_FORCE_BLOCKING       -                 YESNO
BFB_MAX_BLOCKING_TIME_MINUTES      BFB_MAX_BLOCKING_TIME            -                 BFBMAXTIME
BFB_MONITOR_BOT_ATTACK             START_BRUTE_FORCE_BLOCKING       -                 YESNO
BFB_MONITOR_MAIL                   START_BRUTE_FORCE_BLOCKING       -                 YESNO
BFB_USE_OWN_MAIL_LOGFILES          BFB_MONITOR_MAIL                 -                 YESNO
BFB_MAIL_LOGFILE                   BFB_USE_OWN_MAIL_LOGFILES        -                 ABS_PATH
BFB_MONITOR_TELNET                 START_BRUTE_FORCE_BLOCKING       -                 YESNO
BFB_MONITOR_SN                     START_BRUTE_FORCE_BLOCKING       -                 YESNO
BFB_USE_OWN_SN_LOGFILES            BFB_MONITOR_SN                   -                 YESNO
BFB_SN_LOGFILE                     BFB_USE_OWN_SN_LOGFILES          -                 ABS_PATH
BFB_MONITOR_FTPD                   START_BRUTE_FORCE_BLOCKING       -                 YESNO
BFB_USE_OWN_FTPD_LOGFILES          BFB_MONITOR_FTPD                 -                 YESNO
BFB_FTPD_LOGFILE                   BFB_USE_OWN_FTPD_LOGFILES        -                 ABS_PATH
BFB_USE_OWN_AUTH_LOGFILES          START_BRUTE_FORCE_BLOCKING       -                 YESNO
BFB_AUTH_LOGFILE                   BFB_USE_OWN_AUTH_LOGFILES        -                 ABS_PATH
BFB_MONITOR_CRYPTOTROJANER	   START_BRUTE_FORCE_BLOCKING       -                 YESNO
BFB_USE_OWN_CRYPTOTROJANER_LOGFILE BFB_MONITOR_CRYPTOTROJANER       -                 YESNO
BFB_CRYPTOTROJANER_LOGFILE         BFB_USE_OWN_CRYPTOTROJANER_LOGFILE  -              ABS_PATH
#BFB_MONITOR_ASTERISK               START_BRUTE_FORCE_BLOCKING      -                 YESNO
#BFB_ASTERISK_ATTEMPT_NUMBER        BFB_MONITOR_ASTERISK	    -                 NUMERIC
#BFB_USE_OWN_ASTERISK_LOGFILE       BFB_MONITOR_ASTERISK            -                 YESNO
#BFB_ASTERISK_LOGFILE		   BFB_USE_OWN_ASTERISK_LOGFILE     -                 ABS_PATH
BFB_USE_RAMDISK                    START_BRUTE_FORCE_BLOCKING       -                 YESNO
BFB_SEND_ATTACKER_TO_TWITTER       START_BRUTE_FORCE_BLOCKING       -                 YESNO
BFB_ATTACK_TIMES                   START_BRUTE_FORCE_BLOCKING       -                 NUMERIC
BFB_FREE_IP                        START_BRUTE_FORCE_BLOCKING       -                 IPADDRESSES
BFB_FREE_IPV6                      BFB_BLOCK_USE_IPV6               -                 IPADDRESSES6
BFB_BOT_FREE_IP_ADDRESS_V6_N       BFB_BLOCK_USE_IPV6               -                 NUMERIC
BFB_BOT_FREE_IP_ADDRESS_V6_%       BFB_BLOCK_USE_IPV6   BFB_BOT_FREE_IP_ADDRESS_V6_N  IPADDR6
BFB_BOT_FREE_IP_NET_V6             BFB_BLOCK_USE_IPV6               -                 BFBNET6
BFB_UNBLOCK_ALL_TIME               !BFB_MAX_BLOCKING_TIME           -                 CRONTAB
BFB_RESTART_ON_UNBLOCK             !BFB_MAX_BLOCKING_TIME           -                 YESNO
BFB_REQUEST_BLOCKS_VIA_WEBSERVER   START_BRUTE_FORCE_BLOCKING       -                 YESNO
BFB_APACHE_DOCUMENTROOT            BFB_REQUEST_BLOCKS_VIA_WEBSERVER -                 ABS_PATH
BFB_CGI_BIN_DOCUMENTROOT           BFB_REQUEST_BLOCKS_VIA_WEBSERVER -                 ABS_PATH
BFB_RESOLVE_DNS                    BFB_REQUEST_BLOCKS_VIA_WEBSERVER -                 YESNO
BFB_WRITE_LOGENTRY_AFTER_ATTEMPTS  START_BRUTE_FORCE_BLOCKING       -                 YESNO
BFB_EXTENDED_LOG_TO_MESSAGELOG     BFB_WRITE_LOGENTRY_AFTER_ATTEMPTS -                YESNO
BFB_MESSAGE_LOGLEVEL               BFB_WRITE_LOGENTRY_AFTER_ATTEMPTS -                BFB_LEVEL_CUI
BFB_WEBSERVER_LOGFILE_CLEAR        BFB_REQUEST_BLOCKS_VIA_WEBSERVER -                 CRONTAB
BFB_HTML_REFRESH_PATH              BFB_REQUEST_BLOCKS_VIA_WEBSERVER -                 REF_PATH
BFB_BLOCK_TYPE                     START_BRUTE_FORCE_BLOCKING       -                 BFB_BLOCK_TYPE_CUI
BFB_FREE_IP_GROUP_N                START_BRUTE_FORCE_BLOCKING       -                 NUMERIC
BFB_FREE_IP_GROUP_%                START_BRUTE_FORCE_BLOCKING   BFB_FREE_IP_GROUP_N   IPGROUP
BFB_FREE_DYNDNS_DOMAIN             START_BRUTE_FORCE_BLOCKING       -                 YESNO
BFB_FREE_DYNDNS_DOMAIN_N           BFB_FREE_DYNDNS_DOMAIN           -                 NUMERIC
BFB_FREE_DYNDNS_DOMAIN_%           BFB_FREE_DYNDNS_DOMAIN    BFB_FREE_DYNDNS_DOMAIN_N FQDN
BFB_FREE_DYNDNS_UPDATE_ADDR_CRON   BFB_FREE_DYNDNS_DOMAIN           -                 CRONTAB
BFB_MONITOR_BREAKIN_ATTEMPT        START_BRUTE_FORCE_BLOCKING       -                 YESNO
#BFB_MONITOR_CACTI                  START_BRUTE_FORCE_BLOCKING       -                 YESNO
#BFB_CACTI_SERVER_IP_ADDRESS        BFB_MONITOR_CACTI                -                 BFBDOMAIIP
#BFB_CACTI_WEB_ROOT		   BFB_MONITOR_CACTI		    -                 E_ABS_PATH
BFB_MONITOR_WEBACCESS              START_BRUTE_FORCE_BLOCKING       -                 YESNO
BFB_APACHE_USE_404_IGNORE_LIST     BFB_MONITOR_WEBACCESS            -                 YESNO
BFB_MONITOR_UNAUTHORIZED           BFB_MONITOR_WEBACCESS            -                 YESNO
BFB_MONITOR_SLOW_ATTACK		   START_BRUTE_FORCE_BLOCKING       -		      YESNO
BFB_MONITOR_SSH_NEGOTIATE_ERRORS   START_BRUTE_FORCE_BLOCKING       -                 YESNO
BFB_MONITOR_BOT_ATTACK_ATTEMPTS    BFB_MONITOR_BOT_ATTACK           -                 NUMERIC
BFB_BOT_FREE_IP_ADDRESS_N          BFB_MONITOR_BOT_ATTACK           -                 NUMERIC
BFB_BOT_FREE_IP_ADDRESS_%          BFB_MONITOR_BOT_ATTACK BFB_BOT_FREE_IP_ADDRESS_N   BFBDOMAIIP
BFB_BOT_FREE_IP_NET                BFB_MONITOR_BOT_ATTACK           -                 NETWORK
BFB_HTML_INDEX_FOLDER              BFB_REQUEST_BLOCKS_VIA_WEBSERVER -                 NOTEMPTY
BFB_USE_APACHE_VERSION             BFB_REQUEST_BLOCKS_VIA_WEBSERVER -                 BFB_BLOCK_USE_CUI
BFB_MONITOR_MINI_HTTP              START_BRUTE_FORCE_BLOCKING       -                 YESNO
BFB_SEND_MAIL                      START_BRUTE_FORCE_BLOCKING       -                 YESNO
BFB_OWN_WEBDOMAIN_NAME             BFB_REQUEST_BLOCKS_VIA_WEBSERVER -                 BFBDOMAIN
BFB_MAIL_TO_ADDRESS                BFB_SEND_MAIL                    -                 BFBMAILADDR
BFB_MAIL_FROM_ADDRESS              BFB_SEND_MAIL                    -                 BFBMAILADDR
BFB_MAIL_SUBJECT                   BFB_SEND_MAIL                    -                 NOTEMPTY
BFB_MAIL_WITH_WHOIS_REQUEST        BFB_SEND_MAIL                    -                 YESNO
BFB_MAIL_WITH_TRACEROUTE_REQUEST   BFB_SEND_MAIL                    -                 YESNO
BFB_ALL_INFO_IN_SAME_MAIL          BFB_SEND_MAIL                    -                 YESNO
BFB_WRITE_ATTACK_TO_TXTFILE        START_BRUTE_FORCE_BLOCKING       -                 YESNO
BFB_ATTACK_TXTFILE_FILENAME        BFB_WRITE_ATTACK_TO_TXTFILE      -                 ABS_PATH
BFB_ATTACK_FILE_CLEAR_CRON         BFB_WRITE_ATTACK_TO_TXTFILE      -                 CRONTAB
BFB_RUN_COMMAND			   START_BRUTE_FORCE_BLOCKING       -                 YESNO
BFB_RUN_COMMAND_N                  BFB_RUN_COMMAND                  -                 NUMERIC
BFB_RUN_COMMAND_%                  BFB_RUN_COMMAND           BFB_RUN_COMMAND_N        NOTEMPTY
+BFB_SEND_VIA_CURL                 START_BRUTE_FORCE_BLOCKING       -                 YESNO
+BFB_CURL_USERNAME                 BFB_SEND_VIA_CURL                -                 NOTEMPTY
+BFB_CURL_PASSWORD                 BFB_SEND_VIA_CURL                -                 PASSWD
+BFB_CURL_TEXT                     BFB_SEND_VIA_CURL                -                 NOTEMPTY
+BFB_CURL_ADDRESS                  BFB_SEND_VIA_CURL                -                 BFBDOMAIN
+BFB_SEND_TO_TWITTER		   START_BRUTE_FORCE_BLOCKING       -                 YESNO
+BFB_TWITTER_USERNAME		   BFB_SEND_TO_TWITTER		    -		      NOTEMPTY
+BFB_TWITTER_TEXT                  BFB_SEND_TO_TWITTER  	    -		      NOTEMPTY
BFB_MONITOR_SMBWEBCLIENT           START_BRUTE_FORCE_BLOCKING       -                 YESNO
BFB_USE_OWN_SMBWEB_LOGFILES        BFB_MONITOR_SMBWEBCLIENT         -                 YESNO
BFB_SMBWEBCLIENT_LOGFILE           BFB_USE_OWN_SMBWEB_LOGFILES      -                 ABS_PATH
BFB_SHOW_ATTACK_DETAILS_ON_WEB     BFB_REQUEST_BLOCKS_VIA_WEBSERVER -                 YESNO
BFB_MONITOR_PORTSCAN               START_BRUTE_FORCE_BLOCKING       -                 YESNO
BFB_PORTSCAN_RANGES_N              BFB_MONITOR_PORTSCAN             -                 NUMERIC
BFB_PORTSCAN_RANGE_%               BFB_MONITOR_PORTSCAN     BFB_PORTSCAN_RANGES_N     BFBRANGE 
BFB_LOGLEVEL                       START_BRUTE_FORCE_BLOCKING       -                 BFB_LEVEL_CUI
BFB_USE_OWN_KERNEL_LOGFILES        BFB_MONITOR_PORTSCAN             -                 YESNO
BFB_KERNEL_LOGFILE                 BFB_USE_OWN_KERNEL_LOGFILES      -                 ABS_PATH
BFB_SERVER_RUN_AS_SYSLOGSERVER     START_BRUTE_FORCE_BLOCKING       -                 YESNO
BFB_MONITOR_ONLY_LOCAL_SERVER      BFB_SERVER_RUN_AS_SYSLOGSERVER   -                 YESNO
BFB_SERVER_SYSLOGSERVER_HOSTNAME   BFB_MONITOR_ONLY_LOCAL_SERVER    -                 HOSTNAME
BFB_MONITOR_SPECIFIC_PORT          !BFB_BLOCK_REMOTE_SERVER         -                 YESNO
BFB_FREE_LAN_DOMAIN                START_BRUTE_FORCE_BLOCKING       -                 EFQDN
BFB_MONITOR_ADDITIONAL_LOG         START_BRUTE_FORCE_BLOCKING       -                 YESNO
BFB_ADDITIONAL_LOG_SCRIPT          BFB_MONITOR_ADDITIONAL_LOG       -                 ABS_PATH
BFB_BLOCK_PROACTIVE_FROM_ATMA      START_BRUTE_FORCE_BLOCKING       -                 YESNO
BFB_BLOCK_PROACTIVE_CRON           BFB_BLOCK_PROACTIVE_FROM_ATMA    -                 CRONTAB
BFB_BLOCK_PROACTIVE_FROM_DATABASE  START_BRUTE_FORCE_BLOCKING       -                 YESNO
BFB_DAY_TO_CLEAR_PROACTIVE_DATABASE BFB_BLOCK_PROACTIVE_FROM_DATABASE -               NUMERIC
BFB_BLOCK_AGGRESSIVE_IP4           START_BRUTE_FORCE_BLOCKING       -                 BFBIPS4
BFB_BLOCK_AGGRESSIVE_IP6           BFB_BLOCK_USE_IPV6               -                 BFBIPS6
BFB_CHECK_FOR_NEW_VERSION          START_BRUTE_FORCE_BLOCKING       -                 YESNO
BFB_CHECK_NEW_VERSION_CRON         BFB_CHECK_FOR_NEW_VERSION        -                 CRONTAB
BFB_CHECK_NEW_VERSION_TO_ADDRESS   BFB_CHECK_FOR_NEW_VERSION        -                 BFBMAILADDR
BFB_CHECK_NEW_VERSION_FROM_ADDRESS BFB_CHECK_FOR_NEW_VERSION        -                 BFBMAILADDR
BFB_BLOCK_REMOTE_SERVER_IP	   BFB_BLOCK_REMOTE_SERVER          -                 BFBDOMAIIP
BFB_BLOCK_REMOTE_SERVER_PORT       BFB_BLOCK_REMOTE_SERVER          -                 NUMERIC
BFB_BLOCK_REMOTE_FORWARD_CHAIN     BFB_BLOCK_REMOTE_SERVER          -                 NOTEMPTY
BFB_BLOCK_REMOTE_SERVER_USE_OWN_COMMAND BFB_BLOCK_REMOTE_SERVER     -                 YESNO
BFB_BLOCK_REMOTE_SERVER_USER	   BFB_BLOCK_REMOTE_SERVER          -                 NOTEMPTY
BFB_BLOCK_REMOTE_SERVER_PASSWD     BFB_BLOCK_REMOTE_SERVER          -                 PASSWD
BFB_BLOCK_REMOTE_SSH_KEY	   BFB_BLOCK_REMOTE_SERVER	    -                 E_ABS_PATH
BFB_BLOCK_REMOTE_SERVER_OWN_COMMAND BFB_BLOCK_REMOTE_SERVER_USE_OWN_COMMAND -         E_ABS_PATH
BFB_MONITOR_OWNCLOUD		   START_BRUTE_FORCE_BLOCKING       -                 YESNO
BFB_MONITOR_NEXTCLOUD              START_BRUTE_FORCE_BLOCKING       -                 YESNO
BFB_OWNCLOUD_LOG_DIR		   BFB_MONITOR_OWNCLOUD		    -		      E_ABS_PATH
BFB_NEXTCLOUD_LOG_DIR              BFB_MONITOR_NEXTCLOUD            -                 E_ABS_PATH
BFB_SPECIFIC_PORTS_N               BFB_MONITOR_SPECIFIC_PORT        -                 NUMERIC
BFB_SPECIFIC_%_PORTS               BFB_MONITOR_SPECIFIC_PORT    BFB_SPECIFIC_PORTS_N  NUMERIC
BFB_EXTERNAL_INTERFACE             BFB_MONITOR_SPECIFIC_PORT        -                 BFB_INTERFACE_CUI

EOF

 # Set rights for check.d file
 chmod 0600 /etc/check.d/${package}
 chown root /etc/check.d/${package}
}

## -------------------------------------------------------------------------
### Create the exp file
### -------------------------------------------------------------------------
make_exp_file()
{
#--------------------------------------------------------------------------------
printgpl -check_exp ${package_name} ${DATUM} "OJae" "Olaf Jaehrling <eisfair[at]ojaehrling[dot]de>" >/etc/check.d/${package}.exp
#--------------------------------------------------------------------------------
cat >>/etc/check.d/${package}.exp <<EOF

IPGROUP = '()|(RE:IPADDR)-(RE:IPADDR)|(RE:NETWORK)'
 : 'no valid ipgroup specification (ipadesses like 192.168.10.1-192.168.10.3 without space or 192.168.10.0/24)'
IP6GROUP = '()|(RE:IPADDR6)/(RE:NUMERIC)' : 'only ipv6 net allowed'
REF_PATH = '[.]+(RE:ABS_PATH)|(RE:ABS_PATH)+' : 'only the pfad'
BFBDOMAIN = 'http(s)?://[[:alnum:]/~.-]+(:(RE:NUMERIC)(/[[:alnum:]/~.-]*)?)?' : 'no valid URL'
BFBMAILADDR = '[[:alpha:]i/~.-]+|((RE:MAILADDR))|(RE:MAILADDR)([[:space:]]+(RE:MAILADDR))*' : ' 1 or more eMailadresses, use e.g. "aaaa@bbbb.ccc", aaaa@bbbb.ccc dddd@bbbb.ccc or root'
BFB_LEVEL_CUI = 'debug|info|notice|warning|error|crit|alert|emerg' : 'only debug,info,notice,warning,error,crit,alert,emerg are allowed'
BFBRANGE = '(RE:NUMERIC):(RE:NUMERIC)' : 'only 2 numeric letters separated with : are allowed'
BFBDOMAIIP = '(RE:IPADDR46)|(RE:DOMAIN)|(RE:FQDN)' : 'only ip address, FQDN or domain are allow'
#BFBMAXTIME = '[1-9][0-9]' : 'only number between 10 and 99 are allowed'
BFBMAXTIME = '(RE:NUMERIC)' : 'only number between 10 and 99 are allowed'
BFB_BLOCK_TYPE_CUI = 'DROP|REJECT'
 : 'no valid block type, should be DROP or REJECT'
BFB_BLOCK_USE_CUI = '1|2'
 : 'no valid block type, should be 1 or 2'
BFB_WAITTIME_CUI = '10|15|20' : 'no valid wait time, should be 10,15 or 20'
BFBNET6 = '(RE:IPADDR6)/(RE:NUMERIC)' : 'no valid ipv6 network specification, should be a network'
BFBTABLES_CUI = 'nftables|iptables' : 'only iptables or nftables are allowed. Default iptables'
BFB_INTERFACE_CUI = '(RE:NOTEMPTY)' : 'please select a NIC'
BFBIPS4 = '()|((RE:IPADDR)(,+(RE:IPADDR))*|(,+(RE:NETWORK)))|(RE:NETWORK)(,+(RE:NETWORK)|(,+(RE:IPADDR)))*' : 'only blanc, ipv4 addresses/networks allowed separated with comma'
BFBIPS6 = '()|((RE:IPADDR6)|(RE:BFBNET6))(,+(RE:IPADDR6)|(,+(RE:BFBNET6)))*' : 'only blanc, ipv6 addresses/networks allowed separated with comma'
EOF

 # Set rights for exp file
 chmod 0600 /etc/check.d/${package}.exp
 chown root /etc/check.d/${package}.exp
}
### -------------------------------------------------------------------------
### Create the ext file
### -------------------------------------------------------------------------

make_ext_file()
{
#--------------------------------------------------------------------------------
printgpl -check_ext ${package_name} ${DATUM} "OJae" "Olaf Jaehrling <eisfair[at]ojaehrling[dot]de>" >/etc/check.d/${package}.ext
#--------------------------------------------------------------------------------
cat >>/etc/check.d/${package}.ext <<EOF

if ( bfb_monitor_owncloud == "yes" && bfb_monitor_nextcloud == "yes" )
then
    error "only BFB_MONITOR_OWNCLOUD or BFB_MONITOR_NEXTCLOUD are allowed"
fi

#if (bfb_use_iptables_nftables == "nftables" && bfb_monitor_specific_port == "yes" )
#then
#    error "BFB_MONITOR_SPECIFIC_PORT is only with iptables compatible"
#fi

stat ("/usr/sbin/iptables", test)
if ("\$test_res" == "OK")
then
    set iiptables = "yes"
else
    set iiptables = "no"
fi

stat ("/usr/sbin/nft", test)
if ("\$test_res" == "OK")
then
    set nfftables = "yes"
else
    set nfftables = "no"
fi

if (bfb_use_iptables_nftables == "iptables" && iiptables == "no" )
then
    error "BFB_USE_IPTABLES_NFTABLES is set to iptables but iptables is not installed"
fi

if (bfb_use_iptables_nftables == "nftables" && nfftables == "no" )
then
    error "BFB_USE_IPTABLES_NFTABLES is set to nftables but nftables is not installed"
fi

if ( bfb_max_blocking_time == "yes" )
then
    if ( bfb_use_iptables_nftables == "iptables" )
    then
        if ( bfb_max_blocking_time_minutes > 99 || bfb_max_blocking_time_minutes < 10 )
        then
            error "only number between 10 and 99 are allowed"
        fi
    fi
    if ( bfb_max_blocking_time_minutes < 60 )
    then
        if ( bfb_max_blocking_time == "yes" && bfb_send_attacker_to_twitter == "yes" && bfb_block_proactive_from_atma == "yes" )
        then
            error "only BFB_MAX_BLOCKING_TIME and BFB_BLOCK_PROACTIVE_FROM_ATMA or BFB_MAX_BLOCKING_TIME and BFB_SEND_ATTACKER_TO_TWITTER are allowed or BFB_MAX_BLOCKING_TIME must greater than 59"
        fi
    fi

    if ( bfb_use_iptables_nftables == "nftables" )
    then
        if ( bfb_max_blocking_time_minutes < 10 )
        then
            error "not less than 10 minutes are allowed"
        fi
    fi

fi


EOF

 # Set rights for exp file
 chmod 0600 /etc/check.d/${package}.ext
 chown root /etc/check.d/${package}.ext
}

make_debian_file()
{
 internal_conf_file=${1}
 (
echo "#------------------------------------------------------------------------------"
echo "# /etc/default/brute_force_blocking - configuration file for brute_force_blocking"
echo "#"
echo "# Creation   :  2023-03-04 OJae"
echo "# Last Update:  2023-03-04 OJae"
echo "#"
echo "# Copyright (c) Olaf Jaehrling eisfair(at)ojaehrling(dot)de"
echo "#"
echo "# This program is free software; you can redistribute it and/or modify"
echo "# it under the terms of the GNU General Public License as published by"
echo "# the Free Software Foundation; either version 2 of the License, or"
echo "# (at your option) any later version."
echo "#------------------------------------------------------------------------------"
echo ""
echo ""
echo "#------------------------------------------------------------------------------"
echo "# Brute Force Blocking common configuration"
echo "#------------------------------------------------------------------------------"
echo ""
echo "START_BRUTE_FORCE_BLOCKING='yes'  # start brute_force_blocking yes/no"
echo "BFB_WAITTIME='$BFB_WAITTIME'"
echo "BFB_BLOCK_USE_IPV6='$BFB_BLOCK_USE_IPV6'"
echo "BFB_LOGLEVEL='$BFB_LOGLEVEL'"
echo "BFB_USE_RAMDISK='$BFB_USE_RAMDISK'"
echo "BFB_USE_IPTABLES_NFTABLES='$BFB_USE_IPTABLES_NFTABLES'"
echo "                                  # use iptables or nftables"
echo "BFB_RUN_IN_DEBUG_MODE='$BFB_RUN_IN_DEBUG_MODE'"
echo "BFB_DEBUGLOG_CRON_LOGROTATE='$BFB_DEBUGLOG_CRON_LOGROTATE'"
echo "                                  # interval to rotate debuglog"
echo "BFB_ATTACK_TIMES='$BFB_ATTACK_TIMES'"
echo "                                  # blocked becomes"
echo "BFB_BLOCK_TYPE='$BFB_BLOCK_TYPE'"
echo "BFB_MAX_BLOCKING_TIME='$BFB_MAX_BLOCKING_TIME'"
echo "BFB_MAX_BLOCKING_TIME_MINUTES='$BFB_MAX_BLOCKING_TIME_MINUTES'"
echo "                                  # Minutes after deblock ip address"
echo "BFB_UNBLOCK_ALL_TIME='$BFB_UNBLOCK_ALL_TIME'"
echo "BFB_RESTART_ON_UNBLOCK='$BFB_RESTART_ON_UNBLOCK'"
echo "                                  # addresses yes/no"
echo "BFB_RESOLVE_DNS='$BFB_RESOLVE_DNS'"
echo "BFB_CHECK_FOR_NEW_VERSION='$BFB_CHECK_FOR_NEW_VERSION'"
echo "                                  # yes/no"
echo "#------------------------------------------------------------------------------"
echo "# Brute Force Blocking Monitor configuration"
echo "#------------------------------------------------------------------------------"
echo ""
echo "BFB_MONITOR_MAIL='$BFB_MONITOR_MAIL'"
echo "BFB_MONITOR_PORTSCAN='$BFB_MONITOR_PORTSCAN'"
echo "BFB_MONITOR_BOT_ATTACK='$BFB_MONITOR_BOT_ATTACK'"
echo "BFB_MONITOR_SLOW_ATTACK='$BFB_MONITOR_SLOW_ATTACK'"
echo "BFB_MONITOR_SSH_NEGOTIATE_ERRORS='$BFB_MONITOR_SSH_NEGOTIATE_ERRORS'"
echo "                                  # monitor Unable to negotiate no matching key"
echo "                                  # exchange method found"
echo "BFB_MONITOR_SPECIFIC_PORT='$BFB_MONITOR_SPECIFIC_PORT'"
echo "                                  # ports"
echo "BFB_SPECIFIC_PORTS_N='$BFB_SPECIFIC_PORTS_N'"
echo "BFB_SPECIFIC_1_PORTS='$BFB_SPECIFIC_1_PORTS'"
echo "BFB_EXTERNAL_INTERFACE='$BFB_EXTERNAL_INTERFACE'"
echo "BFB_MONITOR_BREAKIN_ATTEMPT='$BFB_MONITOR_BREAKIN_ATTEMPT'"
echo "                                  # yes/no"
echo "BFB_MONITOR_WEBACCESS='$BFB_MONITOR_WEBACCESS'"
echo "                                  # yes/no"
echo "BFB_MONITOR_UNAUTHORIZED='$BFB_MONITOR_UNAUTHORIZED'"
echo "BFB_APACHE_USE_404_IGNORE_LIST='$BFB_APACHE_USE_404_IGNORE_LIST'"
echo "                                  # ignore dummy files like favicon"
echo "BFB_MONITOR_CRYPTOTROJANER='$BFB_MONITOR_CRYPTOTROJANER'"
echo "                                  # cryptotrojanerfiles"
echo "BFB_MONITOR_OWNCLOUD='$BFB_MONITOR_OWNCLOUD'"
echo "BFB_MONITOR_NEXTCLOUD='$BFB_MONITOR_NEXTCLOUD'"
echo "BFB_MONITOR_ADDITIONAL_LOG='$BFB_MONITOR_ADDITIONAL_LOG'"
echo "BFB_MESSAGE_LOGLEVEL='$BFB_MESSAGE_LOGLEVEL'"
echo ""
echo "#------------------------------------------------------------------------------"
echo "# Brute Force Blocking free ip address configuration"
echo "#------------------------------------------------------------------------------"
echo ""
echo "BFB_FREE_IP='$BFB_FREE_IP'"
echo "                                  # never to block ip adresses"
echo "BFB_FREE_IPV6='$BFB_FREE_IPV6'"
echo "                                  # never to block ipv6 adresses"
echo "BFB_FREE_IP_GROUP_N='$BFB_FREE_IP_GROUP_N'"
echo "                                  # adresses"
echo "BFB_FREE_IP_GROUP_1='$BFB_FREE_IP_GROUP_1'"
echo "                                  # never to block ip adress group like"
echo "                                  # 192.168.0.1-192.168.0.10"
echo "BFB_FREE_IP_GROUP_2='$BFB_FREE_IP_GROUP_2'"
echo "                                  # never to block ip adress group like"
echo "                                  # 192.168.0.1-192.168.0.10"
echo "BFB_FREE_LAN_DOMAIN='$BFB_FREE_LAN_DOMAIN'"
echo "BFB_FREE_DYNDNS_DOMAIN='$BFB_FREE_DYNDNS_DOMAIN'"
echo "BFB_FREE_DYNDNS_DOMAIN_N='$BFB_FREE_DYNDNS_DOMAIN_N'"
echo "BFB_FREE_DYNDNS_DOMAIN_1='$BFB_FREE_DYNDNS_DOMAIN_1'"
echo "                                  # DYNDNS hosts"
echo "BFB_FREE_DYNDNS_DOMAIN_2='$BFB_FREE_DYNDNS_DOMAIN_2'"
echo "                                  # DYNDNS hosts"
echo "BFB_FREE_DYNDNS_UPDATE_ADDR_CRON='$BFB_FREE_DYNDNS_UPDATE_ADDR_CRON'"
echo "                                  # DYNDNS hosts"
echo ""
echo "#------------------------------------------------------------------------------"
echo "# Brute Force Blocking BOT-Attack configuration"
echo "#------------------------------------------------------------------------------"
echo ""
echo "BFB_MONITOR_BOT_ATTACK_ATTEMPTS='$BFB_MONITOR_BOT_ATTACK_ATTEMPTS'"
echo "                                  # Number of attempts to block"
echo "BFB_BOT_FREE_IP_NET='$BFB_BOT_FREE_IP_NET'"
echo "                                  # network to allow ssh after bot-attack"
echo "BFB_BOT_FREE_IP_ADDRESS_N='$BFB_BOT_FREE_IP_ADDRESS_N'"
echo "                                  # bot-attack"
echo "BFB_BOT_FREE_IP_ADDRESS_1='$BFB_BOT_FREE_IP_ADDRESS_1'"
echo "                                  # ip address to allow ssh after bot-attack"
echo "BFB_BOT_FREE_IP_ADDRESS_V6_N='$BFB_BOT_FREE_IP_ADDRESS_V6_N'"
echo "                                  # bot-attack"
echo "BFB_BOT_FREE_IP_ADDRESS_V6_1='$BFB_BOT_FREE_IP_ADDRESS_V6_1'"
echo "                                  # ip v6 address to allow ssh after bot-attack"
echo "BFB_BOT_FREE_IP_NET_V6='$BFB_BOT_FREE_IP_NET_V6'"
echo "                                  # network to allow ssh after bot-attack"
echo ""
echo "#------------------------------------------------------------------------------"
echo "# Brute Force Blocking logfiles configuration"
echo "#------------------------------------------------------------------------------"
echo ""
echo "BFB_WRITE_LOGENTRY_AFTER_ATTEMPTS='$BFB_WRITE_LOGENTRY_AFTER_ATTEMPTS'"
echo "                                  # enable log to write attemps into logfile"
echo "BFB_EXTENDED_LOG_TO_MESSAGELOG='$BFB_EXTENDED_LOG_TO_MESSAGELOG'"
echo "                                  # log all attack-tries in /var/log/messages"
echo "                                  # after block? yes/no"
echo "BFB_USE_OWN_MAIL_LOGFILES='$BFB_USE_OWN_MAIL_LOGFILES'"
echo "BFB_MAIL_LOGFILE='$BFB_MAIL_LOGFILE'"
echo "                                  # logfile from MAIL"
echo "BFB_MAILMAIN_LOGFILE='$BFB_MAILMAIN_LOGFILE'"
echo "                                  # mainlogfile from MAIL"
echo "BFB_USE_OWN_AUTH_LOGFILES='$BFB_USE_OWN_AUTH_LOGFILES'"
echo "BFB_AUTH_LOGFILE='$BFB_AUTH_LOGFILE'"
echo "                                  # logfile for ssh logins"
echo "BFB_USE_OWN_KERNEL_LOGFILES='$BFB_USE_OWN_KERNEL_LOGFILES'"
echo "BFB_KERNEL_LOGFILE='$BFB_KERNEL_LOGFILE'"
echo "                                  # logfile for kernel messages"
echo "BFB_USE_OWN_CRYPTOTROJANER_LOGFILE='$BFB_USE_OWN_CRYPTOTROJANER_LOGFILE'"
echo "                                  # use own logfile for syslog messages?"
echo "BFB_CRYPTOTROJANER_LOGFILE='$BFB_CRYPTOTROJANER_LOGFILE'"
echo "                                  # logfile for syslog messages"
echo "BFB_USE_OWN_APACHE2_LOGFILES='$BFB_USE_OWN_APACHE2_LOGFILES'"
echo "BFB_APACHE2_ACCESS_LOGFILE='$BFB_APACHE2_ACCESS_LOGFILE'"
echo "                                  # accesslogfile from apache"
echo "BFB_APACHE2_ERROR_LOGFILE='$BFB_APACHE2_ERROR_LOGFILE'"
echo "                                  # errorlogfile from apache"
echo ""
echo "#------------------------------------------------------------------------------"
echo "# Brute Force Blocking portscan configuration"
echo "#------------------------------------------------------------------------------"
echo ""
echo "BFB_PORTSCAN_RANGES_N='$BFB_PORTSCAN_RANGES_N'"
echo "BFB_PORTSCAN_RANGE_1='$BFB_PORTSCAN_RANGE_1'"
echo "BFB_PORTSCAN_RANGE_2='$BFB_PORTSCAN_RANGE_2'"
echo "BFB_PORTSCAN_RANGE_3='$BFB_PORTSCAN_RANGE_3'"
echo "BFB_PORTSCAN_RANGE_4='$BFB_PORTSCAN_RANGE_4'"
echo "BFB_PORTSCAN_RANGE_5='$BFB_PORTSCAN_RANGE_5'"
echo ""
echo "#------------------------------------------------------------------------------"
echo "# Brute Force Blocking syslog-server configuration"
echo "#------------------------------------------------------------------------------"
echo ""
echo "BFB_SERVER_RUN_AS_SYSLOGSERVER='$BFB_SERVER_RUN_AS_SYSLOGSERVER'"
echo "                                  # run this eisfairserver as syslogserver?"
echo "                                  # yes/no"
echo "BFB_MONITOR_ONLY_LOCAL_SERVER='$BFB_MONITOR_ONLY_LOCAL_SERVER'"
echo "                                  # BFB will be monitor only the local server"
echo "BFB_SERVER_SYSLOGSERVER_HOSTNAME='$BFB_SERVER_SYSLOGSERVER_HOSTNAME'"
echo "                                  # the hostname from your local server"
echo ""
echo "#------------------------------------------------------------------------------"
echo "# Brute Force Blocking webserver configuration"
echo "#------------------------------------------------------------------------------"
echo ""
echo "BFB_REQUEST_BLOCKS_VIA_WEBSERVER='$BFB_REQUEST_BLOCKS_VIA_WEBSERVER'"
echo "                                  # display to website yes/no"
echo "BFB_USE_APACHE_VERSION='$BFB_USE_APACHE_VERSION'"
echo "BFB_APACHE_DOCUMENTROOT='$BFB_APACHE_DOCUMENTROOT'"
echo "                                  # root from Apache webservers"
echo "BFB_HTML_INDEX_FOLDER='$BFB_HTML_INDEX_FOLDER'"
echo "                                  # html folder for index.html and IP.html"
echo "BFB_CGI_BIN_DOCUMENTROOT='$BFB_CGI_BIN_DOCUMENTROOT'"
echo "                                  # cgi/bin-root from Apache webserver"
echo "BFB_HTML_REFRESH_PATH='$BFB_HTML_REFRESH_PATH'"
echo "                                  # the refresh path for automatic reload from"
echo "                                  # html to cgi file"
echo "BFB_OWN_WEBDOMAIN_NAME='$BFB_OWN_WEBDOMAIN_NAME'"
echo "                                  # your own domainname to see bfb html"
echo "BFB_SHOW_ATTACK_DETAILS_ON_WEB='$BFB_SHOW_ATTACK_DETAILS_ON_WEB'"
echo "                                  # show traceroute and whois printout on"
echo "                                  # webserver"
echo "BFB_WEBSERVER_LOGFILE_CLEAR='$BFB_WEBSERVER_LOGFILE_CLEAR'"
echo "                                  # Time to clear the web log"
echo ""
echo "#------------------------------------------------------------------------------"
echo "# Brute Force Blocking additional logfile configuration"
echo "#------------------------------------------------------------------------------"
echo ""
echo "BFB_ADDITIONAL_LOG_SCRIPT='$BFB_ADDITIONAL_LOG_SCRIPT'"
echo "                                  # the complete path to your own bfb-script"
echo ""
echo "#------------------------------------------------------------------------------"
echo "# Brute Force Blocking block proactive configuration"
echo "#------------------------------------------------------------------------------"
echo "BFB_SEND_ATTACKER_TO_TWITTER='yes' # send Attacker to https://t.co/w18xtMJGJk"
echo ""
echo "BFB_BLOCK_PROACTIVE_FROM_ATMA='$BFB_BLOCK_PROACTIVE_FROM_ATMA'"
echo "                                  # block dangerous ip addresses are listed by"
echo "                                  # atma.es"
echo "BFB_BLOCK_PROACTIVE_CRON='$BFB_BLOCK_PROACTIVE_CRON'"
echo "                                  # cron to update atma.es list"
echo "BFB_BLOCK_PROACTIVE_FROM_DATABASE='$BFB_BLOCK_PROACTIVE_FROM_DATABASE'"
echo "                                  # Block ip address proactiv from database"
echo "BFB_DAY_TO_CLEAR_PROACTIVE_DATABASE='$BFB_DAY_TO_CLEAR_PROACTIVE_DATABASE'"
echo "                                  # clear entries older than days in database"
echo "BFB_BLOCK_AGGRESSIVE_IP4='$BFB_BLOCK_AGGRESSIVE_IP4'"
echo "                                  # Block very aggressive ipv4 addresses"
echo "BFB_BLOCK_AGGRESSIVE_IP6='$BFB_BLOCK_AGGRESSIVE_IP6'"
echo "                                  # Block very aggressive ipv6 addresses"
echo ""
echo "#------------------------------------------------------------------------------"
echo "# Brute Force Blocking information configuration"
echo "#------------------------------------------------------------------------------"
echo ""
echo "BFB_SEND_MAIL='$BFB_SEND_MAIL'"
echo "BFB_MAIL_TO_ADDRESS='$BFB_MAIL_TO_ADDRESS'"
echo "BFB_MAIL_FROM_ADDRESS='$BFB_MAIL_FROM_ADDRESS'"
echo "BFB_MAIL_SUBJECT='$BFB_MAIL_SUBJECT'"
echo "                                  # own text for email subject"
echo "BFB_MAIL_WITH_WHOIS_REQUEST='$BFB_MAIL_WITH_WHOIS_REQUEST'"
echo "                                  # the attacker"
echo "BFB_MAIL_WITH_TRACEROUTE_REQUEST='$BFB_MAIL_WITH_TRACEROUTE_REQUEST'"
echo "                                  # send a email with a traceroute request from"
echo "                                  # the attacker"
echo "BFB_ALL_INFO_IN_SAME_MAIL='$BFB_ALL_INFO_IN_SAME_MAIL'"
echo "                                  # same eMail"
echo "BFB_WRITE_ATTACK_TO_TXTFILE='$BFB_WRITE_ATTACK_TO_TXTFILE'"
echo "                                  # textfile"
echo "BFB_ATTACK_TXTFILE_FILENAME='$BFB_ATTACK_TXTFILE_FILENAME'"
echo "                                  # the textfile for save all attack"
echo "                                  # informations"
echo "BFB_ATTACK_FILE_CLEAR_CRON='$BFB_ATTACK_FILE_CLEAR_CRON'"
echo "                                  # clear the textfile via crontab"
echo "BFB_RUN_COMMAND='$BFB_RUN_COMMAND'"
echo ""
echo "#------------------------------------------------------------------------------"
echo "# Brute Force Blocking Command configuration"
echo "#------------------------------------------------------------------------------"
echo ""
echo "BFB_RUN_COMMAND_N='$BFB_RUN_COMMAND_N'"
echo "BFB_RUN_COMMAND_1='$BFB_RUN_COMMAND_1'"
echo "                                  # command"
echo ""
echo "#------------------------------------------------------------------------------"
echo "# Brute Force Blocking Check new Version "
echo "#------------------------------------------------------------------------------"
echo ""
echo "BFB_CHECK_NEW_VERSION_CRON='$BFB_CHECK_NEW_VERSION_CRON'"
echo "                                  # cronjob for new versionscheck"
echo "BFB_CHECK_NEW_VERSION_TO_ADDRESS='$BFB_CHECK_NEW_VERSION_TO_ADDRESS'"
echo "                                  # email address to send information about new"
echo "                                  # Version"
echo "BFB_CHECK_NEW_VERSION_FROM_ADDRESS='$BFB_CHECK_NEW_VERSION_FROM_ADDRESS'"
echo "                                  # sender email address for new version"
echo ""
echo "#------------------------------------------------------------------------------"
echo "# Brute Force Blocking Own/Nextcloud configuration"
echo "#------------------------------------------------------------------------------"
echo ""
echo "BFB_OWNCLOUD_LOG_DIR='$BFB_OWNCLOUD_LOG_DIR'"
echo "                                  # Owncloud Data Directory"
echo "BFB_NEXTCLOUD_LOG_DIR='$BFB_NEXTCLOUD_LOG_DIR'"
echo "                                  # Nextcloud Data Directory"
echo ""
echo "#------------------------------------------------------------------------------"
echo "# End"
echo "#------------------------------------------------------------------------------"

 ) > ${internal_conf_file}
 # Set rights
 chmod 0600 ${internal_conf_file}
 chown root ${internal_conf_file}
}


### ---------------------------------------------------------------------------
### Main
### ---------------------------------------------------------------------------

# update from old version
read_old_variables

# modify variables from old version
modify_variables

# write new config file
if [ -f /etc/eisfair-system ]
then
    make_config_file /etc/config.d/${package}

    # write default config file
    make_config_file /etc/default.d/${package}

    # write check.d file
    make_check_file

    # write *.exp file
    make_exp_file

    # write *.ext file
    make_ext_file
else
    make_debian_file /etc/default/${package}
fi

#anykey
exit 0

### ---------------------------------------------------------------------------
### End
###----------------------------------------------------------------------------

